/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage");



dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		maxGallerySize         : 0.0,
		currentGallerySize     : 0.0,
		unitString             : 'MB',
		usageTextClass         : undefined,

		/**
		 * widget properties
		 */
		percentageClass        : 'PercentageNormal',
		templateString:"<p>{MemoryUsage}\n    <span dojoAttachPoint=\"statusBar\" class=\"StatusBar LeftMargin TopSmallMargin AlignLeft\" style=\"width: 70px\" title=\"{TotalMemory}: 0 MB / {UsedMemory}: 0 MB\" >\n      <span class=\"InnerStatusBar\">\n      <span dojoAttachPoint=\"percentageClassNode\" class=\"${percentageClass}\" style=\"width:0%\"></span>\n    </span>\n  </span>\n  <span dojoAttachPoint=\"usageTextPercentage\"></span><span dojoAttachPoint=\"usageText\"></span>\n</p>\n",
		translationName        : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget','templates/translation'),

		postCreate: function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.id+'/updateCurrentBytes', this, 'updateCurrentBytes');
		},

		updateUsage : function(/* Object */ usageData) {
		 // summary: Write gallery usage data to class members and update widget.
			this.maxGallerySize     = parseFloat(usageData.maxGallerySize);
			this.currentGallerySize = parseFloat(usageData.currentGallerySize);
			this._updateWidget();
		},

		updateCurrentBytes : function (/* Integer */ kilobytes) {
		 // summary: Change the current gallery usage and update the widget.
			this.currentGallerySize = parseFloat(kilobytes);
			this._updateWidget();
		},

		_updateWidget : function() {
		 // summary: Compose strings with usage percentage, max gallery size and current gallery size
		 //   and update the widget's template attach points.
			var percentage = 100 * this.currentGallerySize / this.maxGallerySize;
			if(percentage > 100) {
				percentage = 100.0;
			}
			var tmpCurrentSize = this.currentGallerySize;
			var tmpMaxSize = this.maxGallerySize;
			if(tmpCurrentSize > tmpMaxSize) {
				tmpCurrentSize = tmpMaxSize;
			}
			var displayPercentageNoDec = dojo.number.round(percentage, 0).toString() + '%';

			var displayCurrentValue = dojo.number.round(tmpCurrentSize/1024,0).toString();
			var displayMaxValue = dojo.number.round(tmpMaxSize/1024,0).toString();
			var displayFreeMemory = dojo.number.round((tmpMaxSize - tmpCurrentSize)/1024,0).toString();

			if(percentage > 90.0) {
				this.percentageClass = 'PercentageCritical';
			} else if(percentage > 60.0) {
				this.percentageClass = 'PercentageMiddle';
			} else {
				this.percentageClass = 'PercentageNormal';
			}

			dojo.attr(this.percentageClassNode, 'class', this.percentageClass);
			dojo.attr(this.percentageClassNode, 'style', { 'width' : displayPercentageNoDec });

			if(this.usageTextClass != undefined) {
				dojo.removeClass(this.usageText);
				dojo.addClass(this.usageText, this.usageTextClass);
			}
			this.statusBar.title = this.translate('TotalMemory') + ': ' + displayMaxValue + ' ' + this.unitString + ' / ' + this.translate('UsedMemory') + ': ' + displayCurrentValue + ' ' + this.unitString;
			this.usageTextPercentage.innerHTML = displayPercentageNoDec + '&nbsp;';
			this.usageText.innerHTML = this.translate('FreeMemory')+ ': ' + displayFreeMemory + ' ' + this.unitString;
		}

});

}

if(!dojo._hasResource['epages.cartridges.de_epages.mediagallery.widget.Filestore']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.mediagallery.widget.Filestore'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.Filestore $Revision: 1.24 $

*/
dojo.provide('epages.cartridges.de_epages.mediagallery.widget.Filestore');






dojo.declare(
	'epages.cartridges.de_epages.mediagallery.widget.Filestore',
	[dojo.data.api.Identity],
	{
		/**
		 * public properties
		 */
		actionViewResponse : "JSONViewResponse",
		url                : '?',                  // request url like '/epages/DemoShop.admin/?'
		siteId             : '',                   //objectId of the rode node (start page)
		id                 : 'Filestore',
		validFileTypes     : '',              		 // media gallery option: filter file list to show only files with these extensions
		alleryUsage        : {},                   // hash with gallery size usage data
		/**
		 * private properties
		 */
		_directoryTree    : undefined, // epages.lang.Hash includes server data about directories
		_JsonIo           : undefined, // epages.io.Json includes server connection

		constructor: function(keywordParameters){
			dojo.mixin(this,keywordParameters);
			this._directoryTree = $H();
			this._JsonIo = new epages.io.Json();
		},

		postMixInProperties: function() {
		// summary: initalize values - adjust properites
			this.inherited("postMixInProperties", arguments);
		},

		// loads the file and directory list from the server
		_loadList: function(directoryPath) {
			var info =  this._directoryTree.existsKey(directoryPath) ? this._directoryTree.get(directoryPath) : undefined;
			if (info && ! info.dirty) {
				return true;
			}

			// get data from server
			var JsonData = this._JsonIo.loadSync(
				this.url+'ViewAction=JSONGetDirectoryList&ObjectID='+this.siteId+'&directory='+directoryPath+'&IgnoreDirectoryNotFound=1',
				undefined,
				undefined,
				true
			);
			if (JsonData.data.status === 'DirectoryNotFound') {
				return false;
			}

			if (JsonData.error) {
				JsonData = this._JsonIo.loadSync(
					this.url+'ViewAction=JSONGetDirectoryList&ObjectID='+this.siteId
				);
			}
			// build internal structure
			var aDirectory = directoryPath.split('/');

			this._directoryTree.set(directoryPath, {
				directories : $A(JsonData.data.directories),
				files       : JsonData.data.files,
				title       : aDirectory.pop(),
				parent      : aDirectory.join('/'),
				dirty       : false,
				node        : (info ? info.node : undefined)
			});

			// propagate new gallery size data
			this.galleryUsage = JsonData.data.galleryUsage;
			return true;
		},

		_fetch: function (directory) {
			var directores = this._directoryTree.get(directory).directories;
			var items = [];
			var i;
			$A(directores).each( function(el) {
				items.push({
					title   : el.name,
					isFolder: el.hasSub,
					children: el.hasSub == 1 ? [] : undefined,
					directory: directory + '/' + el.name
				});
			});
			return items;
		},

		_fetchItems: function(keywordArgs, findCallback, errorCallback){
			if(this._loadList(keywordArgs.query.id) && typeof findCallback == 'function') {
				findCallback(this._fetch(keywordArgs.query.id), keywordArgs);
			} else {
				errorCallback(true,keywordArgs);
			}
		},

		getFiles: function(directory){
			if(this._loadList(directory)){
				var files = this._directoryTree.get(directory).files;
				if($A(files).length != 0){
					// list of allowed extensions
					var fileTypeArray = this._convertFileTypeArray(this.validFileTypes);

					$A(files).each(function (el) {
						el.title = el.name;
						el.directory = el.directory;
						el.path = el.path;
						el.canDelete='true';
						el.canChangeTitle='true';
						// toggle as disabled file?
						var isValidExt = false;
						var extension = el.extension.replace(/\W/g, ''); // ".gif" => "gif"
						if(fileTypeArray) {
							for( var j=0,jLength=fileTypeArray.length ; j<jLength ; j++ ) {
								if(extension.match(new RegExp(fileTypeArray[j], "i"))) {
									isValidExt = true;
								}
							}
						} else {
							isValidExt = true; //default case
						}
						if(!isValidExt) {
							el.disabled = true;
						} else {
							el.disabled = false;
						}
					});
					return files;
				}
			}
			return;
		},

		hasAttribute: function(node, attributeName){
			return node[attributeName] !== undefined;
		},

		getLabel: function(item){
			if(item.title !== undefined){
				return item.title;
			}
			return undefined;
		},

		getIdentity: function(item){
			if(item.directory !== undefined){
				return item.directory;
			}
			return undefined;
		},

		getValue: function(item, attribute){
			console.warn('getValue %s', attribute);
		},

		getValues: function(item, attribute){
			if (attribute == 'children' && this._loadList(item.directory)) {
				return this._fetch(item.directory);
			}
			else{
				console.error('getValues() unknown attribute', attribute);
			}
		},

		isItemLoaded: function(something){
			//console.debug('isItemLoaded');
			return true;
		},

		resetCache: function (directory) {
			this._directoryTree.get(directory).dirty = true;
		},

		recursiveResetCache: function (directory) {
			var keys = this._directoryTree.keys();
			var dirDel = directory + '/';
			var dirLen = dirDel.length;
			this._directoryTree.remove(directory);
			for( var i=0,iLength=keys.length ; i<iLength ; i++ ) {
				if (keys[i].substr(0, dirLen) == dirDel) {
					this._directoryTree.remove(keys[i]);
				}
			}
		},

		_send: function (params, opt) {
			if(params.ObjectID  == undefined){
				params.ObjectID = this.siteId;
			}
			var result  = this._JsonIo.loadSync(this.url, params);
			return result;

		},

		renameFile: function (directory,SourceFile,TargetFileName) {
			if(TargetFileName == undefined || TargetFileName == '') {
				return false;
			}

			var JsonData = undefined;
			var cleanSourceFile = this.removeMediaGalleryFromString(SourceFile);

			// nothing changed?
			if(TargetFileName === cleanSourceFile) {
				dojo.publish(this.id+'/onSuccess',[]);
				return TargetFileName;
			}

			JsonData = this._send({
				ChangeAction:   "JSONRenameFile",
				SourceFile:     cleanSourceFile,
				TargetFileName: TargetFileName,
				ViewAction:     this.actionViewResponse
			});
			if(typeof JsonData) {
				if(JsonData.data) {
					// filtered file name
					if(JsonData.data.ResultingFilename) {
						TargetFileName = JsonData.data.ResultingFilename;
					}

					this._directoryTree.get(directory).dirty = true;
					dojo.publish(this.id+'/renamedFile',[SourceFile,TargetFileName,directory]);
					dojo.publish(this.id+'/onSuccess',[]);
					return TargetFileName;
				}
				else {
					// error: target file already exists
					if(JsonData.error.data.Errors) {
						dojo.publish(this.id+'/onError',[{Errors: JsonData.error.data.Errors}]);
						return false;
					}
				}
			}
			else{
				return false;
			}
		},

		deleteFiles: function(selectedNodes,directory) {
			var selectedFiles = []; // Array with Filenames
			for( var i=0,iLength=selectedNodes.length ; i<iLength ; i++ ) {
				if(selectedNodes[i].canDelete){
					selectedFiles.push(this.removeMediaGalleryFromString(selectedNodes[i].path));
				}
			}
			if(selectedFiles.length > 0) {
				var jsonResult = this._send({
					ChangeAction: "JSONDeleteFile",
					File:         selectedFiles,
					ViewAction:   this.actionViewResponse
				});

				if(jsonResult) {
					this.resetDirectory(directory);
					dojo.publish(this.id+'/deleteFiles',[selectedFiles]);
					if(jsonResult.data && jsonResult.data.currentGallerySize) {
						dojo.publish(this.id+'/updateCurrentBytes', [ jsonResult.data.currentGallerySize ] );
					}
					return true;
				}
				else{
					return false;
				}
			}
		},

		getInfo: function (directory) {
			if (this._loadList(directory)){ // make sure that node exists
				return this._directoryTree.get(directory);
			}
			return undefined;
		},

		getNode: function(directory) {
			// also dirty infos contains correct node
			if (this._directoryTree.existsKey(directory)) {
				return this.getInfo(directory);
			}
			return undefined;
		},

		getNodeTitle: function (directory) {
			//return this.getNode(directory).title;
		},

		createDirectory: function (name,parentDirectory) {
			var info = this.getInfo(parentDirectory);
			var JsonData = undefined;
			var targetdirectory = this.removeMediaGalleryFromString(parentDirectory);
			JsonData = this._send({
				TargetDirectory: targetdirectory ? targetdirectory : "",
				ChangeAction:   "JSONCreateDirectory",
				DirectoryName:  name,
				ViewAction:     this.actionViewResponse
			});

			// different name was created?
			if(JsonData) {
				if(JsonData.data) {
					if(JsonData.data.ResultingDirectory) {
						name = JsonData.data.ResultingDirectory;
					}
					if(JsonData.data.currentGallerySize) {
						dojo.publish(this.id+'/updateCurrentBytes', [ JsonData.data.currentGallerySize ] );
					}
				}
				else {
					// error creating
					if(JsonData.error.data.Errors) {
						dojo.publish(this.id+'/onError',[{Errors: JsonData.error.data.Errors}]);
						return false;
					}
				}

				if(!info){
					info = this.getInfo(parentDirectory);
				} else {
					// add new directory to parent
					info.hasSub = true;
					info.directories.push({
						name: name,
						hasSub: 0
					});
				}
				// add new directory to cache + add node
				var directory = parentDirectory + '/' + name;
				this._directoryTree.set(directory, {
					directories : $A(),
					files       : [],
					title       : name,
					parent      : parentDirectory,
					node        : directory.node
				});

				dojo.publish(this.id+'/createDirectory',[directory]);
				return true;
			}
			else{
				return false;
			}
		},

		renameDirectory: function (name,oldName,directory) {
			if(name == undefined || name == ''){
				return false;
			}
			var info = this.getInfo(directory);
			var JsonData = undefined;
			JsonData = this._send({
				SourceDirectory: this.removeMediaGalleryFromString(directory),
				ChangeAction:   "JSONRenameDirectory",
				TargetDirectoryName:  name,
				ViewAction:     this.actionViewResponse
			});
			// different name was used for rename?
			if(typeof JsonData) {

				if(JsonData.data) {
					if(JsonData.data.ResultingDirectory) {
						name = JsonData.data.ResultingDirectory;
					}
				}
				else {
					// error : aleady exists!
					if(JsonData.error.data.Errors) {
						dojo.publish(this.id+'/onError',[{Errors: JsonData.error.data.Errors}]);
						return false;
					}
				}

				this.resetCache(info.parent);
				this.recursiveResetCache(oldName);

				dojo.publish(this.id+'/renameDirectory',[name,directory]);
				return name;
			}
			else{
				return false;
			}
		},

		deleteDirectory: function (directory) {
			var info = this.getInfo(directory);
			var jsonResult = this._send({
				Directory:      this.removeMediaGalleryFromString(directory),
				ChangeAction:   "JSONDeleteDirectory",
				ViewAction:     this.actionViewResponse
			});
			if(jsonResult){
				this.resetCache(info.parent);
				this.recursiveResetCache(directory);
				dojo.publish(this.id+'/deleteDirectory',[directory]);
				if(jsonResult.data && jsonResult.data.currentGallerySize) {
					dojo.publish(this.id+'/updateCurrentBytes', [ jsonResult.data.currentGallerySize ] );
				}
				return true;
			}
			else{
				return false;
			}
		},

		resetDirectory: function (directory) {
			var node = this.getNode(directory);
			this.resetCache(directory);
			this._loadList(directory);
			var info = this.getInfo(directory);
			info.node = node;
		},

		copyImageFromImageDb: function (directory, files) {
			var dir = this.removeMediaGalleryFromString(directory);
			var jsonResult = this._send({
				ChangeAction:     "JSONCopyImageFromImageDb",
				TargetDirectory: dir ? dir : "",
				SourceFile:       files,
				ViewAction:       this.viewAction
			});
			if(jsonResult){
				this.resetDirectory(directory);
				if(jsonResult.data && jsonResult.data.currentGallerySize) {
					dojo.publish(this.id+'/updateCurrentBytes', [ jsonResult.data.currentGallerySize ] );
				}
				return true;
			}
			else{
				return false;
			}
		},

		removeMediaGalleryFromString: function (/* String */ directory) {
		   // summary: removes "MediaGallery" string from given directory path
		   // description: If the given directory contains the string "MediaGallery", it removes
		   // 	the string. In addition a leading path slash (slash or backslash) is removed.
		   // example:
		   //    var jailedDir = removeMediaGalleryFromString('MediaGallery/test/mydir');
		   //		 will return 'test/mydir'.
		   // returns: directory name/path without "MediaGallery" | string
			if(!directory){
				return;
			}

			var str = directory.replace(/^MediaGallery/, '');
			str = str.replace(/^[\\\/]/, '');

			return str; // String
		},

		setFileTypes: function(/* String */ fileTypes) {
		   // summary: updates the list of allowed file extensions
			if(typeof(fileTypes) === "string" && (this.validFileTypes != fileTypes)) {
				this.validFileTypes = fileTypes;
			}
		},

		_convertFileTypeArray: function(/* String */ validFileTypeString) {
		   // summary: converts a string with a ";"-seperated list of file extensions into an array
		   // example:
		   //    var fileTypeArray = this._convertFileTypeArray(this.validFileTypes);
		   // returns: array of file extensions | array of string
			var fileTypeArray;
			if(validFileTypeString) {
				fileTypeArray = validFileTypeString.split(";");
			}
			return fileTypeArray;
		}

});

dojo.extend(epages.cartridges.de_epages.mediagallery.widget.Filestore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Filetree"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Filetree"] = true;
/*
	Copyright (c) 2006-2009, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.Filetree $Revision: 1.17 $

*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Filetree");






dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.Filetree",
	[dijit.Tree],
	{
		/**
		* public properties
		*/
		listId            : "",
		viewAction        : "JSONViewResponse",
		url               : "?",
		directory         : 'MediaGallery',
		label             : 'Files',
		persist            : false,
		/**
		* private properties
		*/
		_currentDirectory : undefined,
		_lastSelectedNode : undefined,
		/**
		* public methods
		*/
		postCreate  : function() {
			this.inherited("postCreate", arguments);
			this._currentDirectory = this.directory;
			this.rootNode.item.id = this.directory;
			this.rootNode.item.directory = this.directory;
			if (this.listId != "") {
				dojo.subscribe(this.listId + '/rename', this.model.store, 'renameFile');
			}
		},

		_getFileList : function(directory) {
			var files =  this.model.store.getFiles(directory);
			return files;
		},

		onClick: function(item, node){
			if(item && item.children !== undefined){
				this._expandNode(node);
			}
			if(this.lastFocused === undefined){ 
				this.lastFocused = node;
			}
			//check if title of tree was clicked and load files if neccessary
			var directory = undefined;
			if(item && item.root == true){
				var files = this._getFileList(this.directory);
				if(this.listId != ""){
					var filelist = $$(this.listId);
					if(files){
					filelist.setChildren(files);
				}
					else{
						filelist.setChildren([]);
					}
				}
				this._lastSelectedNode = node;
				directory = this.directory;
				this._currentDirectory = this.directory;
			}
			if(item && item.root != true){
				directory = item.directory;
				this.model.store._loadList(directory);
				this._lastSelectedNode = node;
				this._currentDirectory = directory;
				var files = this._getFileList(directory);
				if(this.listId != ""){
					var filelist = $$(this.listId);
					if(files){
						filelist.setChildren(files);
					}
					else{
						filelist.setChildren([]);
					}
				}
			}
			//fix for ie without timeout is can not give focus to element
			window.setTimeout(dojo.hitch(this,this.focusNode,node),10);
			dojo.publish(this.id+'/select',[{node:node, currentDirectory: directory}]);
		},

		getCurrentDirectory: function () {
		// summary: get full path name
			return this._currentDirectory; //String?
		},

		getCurrentDirectoryName: function () {
		// summary: get folder name
		// returns: folder name
			if(this._lastSelectedNode == undefined) {
				return false;
			}
			return this._lastSelectedNode.label; //String?
		},

		getLastSelectedNode: function () {
			return this._lastSelectedNode; //String?
		},

		deleteFiles: function(selectedNodes) {
		// summary: delete specified (or selected) files
			if(selectedNodes === undefined && this.listId){
				selectedNodes = $$(this.listId).selectedNodes();
			}
			if(selectedNodes == undefined || selectedNodes.length == 0){
				console.warn('nothing selected');
				return;
			}
			else{
				if(this.model.store.deleteFiles(selectedNodes,this._currentDirectory) == true){
					this.reloadFiles();
				}
				else{
					console.warn('cant delete files');
				}
			}
		},

		createDirectory: function (name) {
			if(this.model.store.createDirectory(name,this._currentDirectory) == true) {
				if(this._lastSelectedNode.item.children == undefined){
					this._lastSelectedNode.item.children = [];
				}
				this._refreshNode(this._lastSelectedNode);
				return true;
			}
			else {
				return false;
			}
		},

		renameDirectory: function (name) {
			if(this._lastSelectedNode == undefined || this._lastSelectedNode.isTree == true){ 
				return;
			}
			var node = this._lastSelectedNode;
			var oldName = node.item.title;
			var newName = this.model.store.renameDirectory(name,oldName,this._currentDirectory);
			if(newName != false)
			{
				// set node elements
				this.setLabelNode(node,newName);
				node.item.directory = node.item.directory.substr(0,node.item.directory.lastIndexOf("/"))+'/'+newName;
				this._collapseNode(node);

				this.onClick(node.item, node);
				return true;
			}
			else {
				return false;
			}
		},

		deleteDirectory: function (directory) {
			//summary: delete given or current directory
			if(directory == undefined){ 
				directory = this._currentDirectory;
			}
			if(this._lastSelectedNode == undefined || this._lastSelectedNode.isTree == true){ 
				return;
			}
			if(this.model.store.deleteDirectory(directory) == true){
				var node = this._lastSelectedNode;
				parentNode = node.getParent();
				var children = parentNode.item.children;
				for( var i=0,iLength=children.length ; i<iLength ; i++ ){
					var child = children[i];
					if(child.directory == directory){
						var deleteIndex = i;
					}
				}
				children.splice(deleteIndex,1);
				if(parentNode.getChildren().length == 1){
					parentNode.isExpandable = false;
				}
				this._refreshNode(parentNode);
				epages.event.fire(parentNode.domNode,'click');
			}
		},


		selectDirectory: function (directory) {
			var node = this._getNodeByDirectory(directory);
			var item = node.item ? node.item : undefined;
			this.onClick(item, node);
		},

		_getNodeByDirectory: function(directory, parentNode) {
			if (parentNode == undefined){ 
				parentNode = this;
			}
			if(directory == this.directory){ 
				return this;
			}
			var nodesWithChildren = [];
			var children = parentNode.getChildren();
			for( var i=0,iLength=children.length ; i<iLength ; i++ ) {
				var node = children[i];
				if (node.item.directory == directory){
					return node;
				}
				if (node.getChildren() && node.getChildren().length > 0){ 
					nodesWithChildren.push(node);
				}
			}
			for( var i=0,iLength=nodesWithChildren.length ; i<iLength ; i++ ) {
				var node = this._getNodeByDirectory(directory, nodesWithChildren[i]);
				if (node != null){ 
					return node;
				}
			}
			return null;
		},

		openNode:function(directory){
			if (directory === undefined || directory == "") {
				directory = this.directory;
			}
			//convert directory from string to array
			var selectedNodePath = new Array();
			var directories = directory.split("/");
			for( var i=0,l=directories.length ; i<l ; i++ ){
				if(i === 0){
					selectedNodePath[i] = directories[i];
				}
				else{
					selectedNodePath[i] = selectedNodePath[i-1]+'/'+directories[i];
				}
			}
			for( var i=0,iLength=selectedNodePath.length ; i<iLength ; i++ ) {
				var directory = selectedNodePath[i];
				var node = this._getNodeByDirectory(directory);
				if(node == undefined){
					this.model.store._loadList(directory);
					node = this._getNodeByDirectory(directory);
				}
				if(node == undefined){
					window.setTimeout(dojo.hitch(this,this.focusNode,this._lastSelectedNode),10);
					return false;
				}
				if (i == selectedNodePath.length - 1) {
					this._lastSelectedNode = node;
					this._currentDirectory = directory;
					//need timeout for ie
					window.setTimeout(dojo.hitch(this,this.focusNode,node),10);
					dojo.publish(this.id+'/select', [{
							node : node,
							currentDirectory : directory
					}]);
					return true;
				}
				else{
					this._lastSelectedNode = node;
					this._currentDirectory = directory;
					this._expandNode(node);
				}
			}
		},

		reloadFiles: function(){
			var files = this._getFileList(this._currentDirectory);
				if(this.listId != ""){
					var filelist = $$(this.listId);
					if(files){
						filelist.setChildren(files);
					}
					else{
						filelist.destroyDescendants();
					}
				}
		},

		getLabelClass: function(/*dojo.data.Item*/ item){
			// summary: user overridable function to return CSS class name to display label
			//if no return value is set dojo adds a class "undefined" to every label in the tree
			return '';
		},

		focusNode: function(node) {
			this._onNodeFocus(node);
		},
		_onNodeFocus: function(/*dijit._Widget*/ node){
			// summary:
			//		Called when a TreeNode gets focus, either by user clicking
			//		it, or programatically by arrow key handling code.
			// description:
			//		It marks that the current node is the selected one, and the previously
			//		selected node no longer is.

			if(node){
				if(node != this.lastFocused && this.lastFocused && !this.lastFocused._destroyed){
					// mark that the previously selected node is no longer the selected one
					this.blurNode();
					if(this.lastFocused){
						this.lastFocused.setSelected(false);
					}
				}

				// mark that the new node is the currently selected one
				dojo.addClass(node.labelNode,"Selected");
				node.setSelected(true);
				this.lastFocused = node;
			}
		},

		blurNode: function() {
			var node = this.lastFocused;
			if(!node){
				return;
			}
			dojo.removeClass(node.labelNode, "Selected");
			var labelNode = node.labelNode;
			dojo.removeClass(labelNode, "dijitTreeLabelFocused");
			labelNode.setAttribute("tabIndex", "-1");
			this.lastFocused = null;
		},

		_refreshNode: function(/*Object*/ node) {
			// summary: Refreshes the given node in the tree.
			// description: There's also a thread on dojo campus:
			//	http://dojocampus.org/content/2008/06/04/refreshing-a-data-store/.
			// example:
			//	_refreshNode(this._lastSelectedNode);
			if(node.isExpanded == true || node.item.children != undefined){
				this._collapseNode(node);
				node.state = "UNCHECKED";
				node.isExpandable = true;
				node._setExpando(false);
				if(node == this.rootNode){
					this.rootNode.item.children = this.model.store.getValues(this.rootNode.item,'children');
				}
				this._expandNode(node);
			}
			else{
				node.state = "UNCHECKED";
				node.isExpandable = false;
				node._setExpando(false);
			}
		},

	setLabelNode: function(node,label){
		node.labelNode.innerHTML = "";
		node.labelNode.appendChild(dojo.doc.createTextNode(label));
	}
});

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Imagedbstore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Imagedbstore"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.Imagedbstore $Revision: 1.7 $

*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Imagedbstore");








dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.Imagedbstore",
	[dojo.data.api.Identity], {
		/**
		* public properties
		*/
		id                : 'Imagedbstore',
		basePath          : epages.vars.ImageDbRoot,
		originalPath      : epages.vars.ImageDbRoot + "/original",
		previewPath       : epages.vars.ImageDbRoot + "/thumbnail",
		translationFile   : "content",
		contentFileName   :  "content.xml",

		/**
		* private properties
		*/
		_XmlIo:           undefined,
		_translation:     undefined,
		_keywords:        undefined,

		constructor: function(keywordParameters){
			dojo.mixin(this,keywordParameters);
			this._XmlIo = new epages.io.Xml();
			this._translation = new epages.io.Translation();
			this._keywords = $H();
			if(this.basePath){
				this._translation.loadLocale(this.basePath + '/' + this.translationFile);
			}else{
				console.warn("epages.vars.ImageDbRoot not defined in "+this.declaredClass);
			}
		},

		/**
		 * private methods
		 */
		_getCategories: function(parentNode) {
			var categories = [];
			if (parentNode.childNodes.length > 0) {
				var categoryNodes = epages.html.getChildNodesByTagName(parentNode, "category");
				for( var i=0,iLength=categoryNodes.length ; i<iLength ; i++ ) {
					var categoryNode = categoryNodes[i];
					var keyword = categoryNode.getAttribute("name");
					var children = this._getCategories(categoryNode);
					categories.push({
						title: this._translation.get(keyword),
						objectId: keyword,
						children: children.length >0 ? children : undefined,
						isFolder: children.length > 0 ? 1 : 0
					});
				}
			}
			return categories;
		},

		_getCollections: function(collectionsNode) {
			var collectionNodes = epages.html.getChildNodesByTagName(collectionsNode, "collection");
			for( var i=0,iLength=collectionNodes.length ; i<iLength ; i++ ) {
				var collection = {
					directory: collectionNodes[i].getAttribute("dir"),
					content:   collectionNodes[i].getAttribute("content")
				};
				var keywordNodes = epages.html.getChildNodesByTagName(collectionNodes[i], "keyword");
				for( var j=0,jLength=keywordNodes.length ; j<jLength ; j++ ) {
					var keyword = keywordNodes[j].getAttribute("name");
					var keywordInfo = this._keywords.get(keyword);
					if (keywordInfo === undefined) {
						keywordInfo = {
							'files'      : [],
							'collections': []
						};
						this._keywords.set(keyword, keywordInfo);
					}
					keywordInfo.collections.push(collection);
				}
			}
		},

		_parse: function () {
			var contentXml = this._XmlIo.loadSync(this.basePath + '/' + this.contentFileName);
			if (contentXml === undefined){
				throw new Error('no content found');
			}

			var contentNode = contentXml.getElementsByTagName("content")[0];
			if (contentNode === undefined){
				throw new Error('no content node found');
			}

			var categoriesNode = contentNode.getElementsByTagName("categories")[0];
			if (categoriesNode === undefined){
				throw new Error('no categories node found');
			}

			var collectionsNode = contentNode.getElementsByTagName("collections")[0];
			if (collectionsNode === undefined){
				throw new Error('no collections node found');
			}

			var categories = this._getCategories(categoriesNode);
			this._getCollections(collectionsNode);
			return categories;
		},

		_fetchItems: function(keywordArgs, findCallback, errorCallback){

			if(typeof findCallback == 'function') {
				findCallback(this._parse(), keywordArgs);
			} else {
				consoleerror('error while _fetch');
				errorCallback(keywordArgs);
			}
		},

		hasAttribute: function(node, attributeName){
			//check if node has specified attribute
			return node[attributeName] !== undefined;
		},

		getLabel: function(item){
			if(item.title !== undefined){ 
				return item.title;
			}
			return undefined;
		},

		getIdentity: function(item){
			if(item.objectId !== undefined){ 
				return item.objectId;
			}
			return undefined;
		},

		getValues: function(item, attribute){
				return item[attribute];
		},

		isItemLoaded: function(something){
			return true;
		},
		/**
		* public methods
		*/
		parseFiles: function(keyword) {
			var keywordInfo = this._keywords.get(keyword);
			// keyword has no files, possible main category
			if (keywordInfo === undefined){ 
				return [];
			}

			// load file names
			var keywordCollections = $A(keywordInfo.collections).grep( function () {return true;});
			for( var i=0,iLength=keywordCollections.length ; i<iLength ; i++ ) {
				var collection = keywordCollections[i];
				var filedir = collection.directory;
				var content = collection.content;
				var contentXml = this._XmlIo.loadSync(this.basePath + '/' + content);
				if (contentXml === undefined){
					throw new Error('no content found');
				}

				var keywordNodes = contentXml.getElementsByTagName("keyword");
				if (keywordNodes === undefined){
					throw new Error('no keywords node found');
				}

				for( var i=0,iLength=keywordNodes.length ; i<iLength ; i++ ) {
					var locKeyword = keywordNodes[i].getAttribute("name");
					var locInfo = this._keywords.get(locKeyword);
					var locFiles = locInfo.files;
					locInfo.collections = $A(locInfo.collections).grep(function (el) {
						return el.content != content;
					});
					var fileNodes = epages.html.getChildNodesByTagName(keywordNodes[i], "file");
					for( var j=0,jLength=fileNodes.length ; j<jLength ; j++ ) {
						var fileName = fileNodes[j].firstChild.data;
						if (fileName != "") {
							if (fileName.lastIndexOf(".") == -1) {
								var extension = "?";
							} else {
								var extension = fileName.substring(fileName.lastIndexOf(".") + 1);
							}
							locFiles.push({
								objectId:     (this.originalPath + "/" + collection.directory + "/" + fileName),
								title:         fileName,
								fullpath:     (this.originalPath + "/" + collection.directory + "/" + fileName),
								preview:      (this.previewPath + "/" + collection.directory + "/" + fileName),
								extension:    extension,
								size:         0,
								mimetype:     "",
								imagewidth:   "",
								imageheight:  "",
								modified:     0,
								templateType: 'image'
							});
						}
					}
				}
			}
			return keywordInfo.files;
		},

		getCurrentPath: function(node) {
			var path=node.title;
			while(node.parent.title) {
				node=node.parent;
				path = node.title+'/' + path;
			}
			return path;
		}
	}
);

dojo.extend(epages.cartridges.de_epages.mediagallery.widget.Imagedbstore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Imagedbtree"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Imagedbtree"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.Imagedbtree $Revision: 1.6 $

*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Imagedbtree");


dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.Imagedbtree",
	[dijit.Tree],
	{
		/**
		* public properties
		*/
		listId            : "",
		label             : 'ImageDB',
		persist            : true,
		/**
		* private properties
		*/
		/**
		* public methods
		*/
		postCreate  : function() {
			this.inherited("postCreate", arguments);
		},

		onClick: function(item, node){
			//check if title of tree was clicked and load files if neccessary
			var filelist = $$(this.listId);
			var directory = this.label;
			if(node && node.isTree == true){
				filelist.destroyDescendants();
			}
			if(item){
				directory = item.title;
				if(this.listId != ""){
					var files = this.store.parseFiles(item.objectId);
					if(files){
						filelist.setChildren(files);
					}
					else{
						filelist.destroyDescendants();
					}
				}
			}
			this.focusNode(node);
			dojo.publish(this.id+'/select',[{node:node, currentDirectory: directory}]);
		},

		focusNode: function(node) {
			this.blurNode();
			try{
				node.labelNode.focus();
			}
			catch(e){
				console.error(e);
			}
			dojo.addClass(node.labelNode,"Selected");
			this.lastFocused = node;
		},

		blurNode: function() {
			var node = this.lastFocused;
			if(!node){
				return;
			}
			dojo.removeClass(node.labelNode, "Selected");
			var labelNode = node.labelNode;
			dojo.removeClass(labelNode, "dijitTreeLabelFocused");
			labelNode.setAttribute("tabIndex", "-1");
			this.lastFocused = null;
		},

		getLabelClass: function(/*dojo.data.Item*/ item){
			// summary: user overridable function to return CSS class name to display label
			//if no return value is set dojo adds a class "undefined" to every label in the tree
			return '';
		}
});

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Filelistitem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Filelistitem"] = true;
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Filelistitem");





dojo.declare(
	"epages.cartridges.de_epages.mediagallery.widget.Filelistitem",
	[epages.widget.Elementlistitem],
	{

		/**
		 * public properties
		 */

		preview:             '',
		fullpath:            '',                   // full path including filname
		directory:           '',
		size:                '',
		mimetype:            '',
		extension:           '',
		imagewidth:          '',
		imageheight:         '',
		previewwidth:        '48',
		previewheight:       '48',
		modified:            '',
		canChangeTitle:      'false',
		canDelete:           'false',
		canOpen:             'false',
		name:                "",
		parentId:            "",
		store:               undefined,
		siteId:              epages.vars.SiteID,
		disabled:            false,
		fileName:            '',

		/**
		 * dojo widget properties
		 */
		imagePath:        epages.themeUrl('images'),
		storeImgBase:     epages.vars.StoreRoot+'/BO/icons',

		templateString     : '', // override epages.widget.Elementlistitem default, without scrinksafe
		templateType       : 'normal',
		defaultTemplateType: 'normal',
		templateString:"<div class=\"filelistitem\">\n  <span class=\"filelistitempreview\">\n    <table cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" height=\"100%\"><tr><td>\n    <div style=\"width:${previewwidth}px; height: auto; max-height:${previewheight}px; overflow: hidden; margin: 0 auto\">\n      <img src=\"${preview}\" alt=\"${fileName}\" title=\"${fileName}\" width=\"100%\" />\n    </div>\n    </td></tr></table>\n  </span>\n  <span dojoAttachPoint=\"nodeTitle\" class=\"filelistitemtitle\">${fileName}</span>\n  <span class=\"filelistiteminputtitle\"><input dojoAttachPoint=\"nodeInputTitle\" value=\"\" style=\"display:none;\"/></span>\n  <div class=\"FileInfo\">\n    <div class=\"filelistitemattributes\" dojoAttachPoint=\"nodePixel\">${imagewidth} &times; ${imageheight}</div>\n    <div class=\"filelistitemattributes\" dojoAttachPoint=\"nodeSize\">${size}</div>\n  </div>\n  <div class=\"ActionButtons\" dojoAttachpoint=\"actionButtonsNode\">\n    <a href=\"javascript: void(0);\" onclick=\"return false;\"\n       unselectable=\"on\" style=\"display:none\"\n       dojoAttachPoint=\"downloadNode\" class=\"CommandLinkSmall\"\n       ><span><span class=\"WithIcon Download\">{DownloadFile}</span></span><a href=\"#\" class=\"DownloadLinkOver\" dojoAttachPoint=\"downloadLinkOverNode\" onclick=\"return false;\"></a></a>\n    <br />\n    <a href=\"javascript: void(0);\" onclick=\"return false\" unselectable=\"on\" style=\"display:none\"\n       dojoAttachPoint=\"deleteNode\" class=\"CommandLinkSmall\"\n       ><span><span class=\"WithIcon Delete\">{Delete}</span></span></a>\n  </div>\n</div>\n",
		_templateMapping   : {
			'normal' : {templateString:"<div class=\"filelistitem\">\n  <span class=\"filelistitempreview\">\n    <table cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" height=\"100%\"><tr><td>\n    <div style=\"width:${previewwidth}px; height: auto; max-height:${previewheight}px; overflow: hidden; margin: 0 auto\">\n      <img src=\"${preview}\" alt=\"${fileName}\" title=\"${fileName}\" width=\"100%\" />\n    </div>\n    </td></tr></table>\n  </span>\n  <span dojoAttachPoint=\"nodeTitle\" class=\"filelistitemtitle\">${fileName}</span>\n  <span class=\"filelistiteminputtitle\"><input dojoAttachPoint=\"nodeInputTitle\" value=\"\" style=\"display:none;\"/></span>\n  <div class=\"FileInfo\">\n    <div class=\"filelistitemattributes\" dojoAttachPoint=\"nodePixel\">${imagewidth} &times; ${imageheight}</div>\n    <div class=\"filelistitemattributes\" dojoAttachPoint=\"nodeSize\">${size}</div>\n  </div>\n  <div class=\"ActionButtons\" dojoAttachpoint=\"actionButtonsNode\">\n    <a href=\"javascript: void(0);\" onclick=\"return false;\"\n       unselectable=\"on\" style=\"display:none\"\n       dojoAttachPoint=\"downloadNode\" class=\"CommandLinkSmall\"\n       ><span><span class=\"WithIcon Download\">{DownloadFile}</span></span><a href=\"#\" class=\"DownloadLinkOver\" dojoAttachPoint=\"downloadLinkOverNode\" onclick=\"return false;\"></a></a>\n    <br />\n    <a href=\"javascript: void(0);\" onclick=\"return false\" unselectable=\"on\" style=\"display:none\"\n       dojoAttachPoint=\"deleteNode\" class=\"CommandLinkSmall\"\n       ><span><span class=\"WithIcon Delete\">{Delete}</span></span></a>\n  </div>\n</div>\n"},
			'image'  : {templateString:"<div class=\"filelistitemImage\">\n  <table cellpadding=\"0\" cellspacing=\"0\" width=\"100%\" height=\"100%\"><tr><td>\n    <img src=\"${preview}\" alt=\"${fileName}\" title=\"${fileName}\" />\n  </td></tr></table>\n</div>\n"}
		},
		translationName  : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget','templates/translation'),
		widgetsInTemplate : true,

		postMixInProperties: function() {
			this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget' , 'templates');
			this.inherited("postMixInProperties", arguments);
			this.fileName = this.title;
			this.title = '';

			if(this.size != '') {
				this.size = epages.localize.formatBytes(this.size, 1);
			}
			// define preview
			if (this.preview == '') {
				this.preview = this.imagePath + '/ico_xl_file_unknown.png';
			}
			else if(this.imagewidth != '' && this.imageheight != '') {
				var ratio = parseInt(this.imagewidth, 10) / parseInt(this.imageheight, 10);
				var previewwidth  = this.previewwidth  != '' ? parseInt(this.previewwidth , 10) : undefined;
				var previewheight = this.previewheight != '' ? parseInt(this.previewheight, 10) : undefined;
				if (previewwidth === undefined && previewheight === undefined){
					previewwidth = parseInt(this.prototype.previewwidth);
				}
				if (previewheight === undefined){
					previewheight = previewwidth;
				}
				if (previewwidth  === undefined){
					previewwidth  = previewheight;
				}

				var calc_previewheight = Math.round(previewwidth / ratio);
				var calc_previewwidth  = Math.round(previewheight * ratio);

				if (previewheight < calc_previewheight){
					previewwidth  = calc_previewwidth;
				}
				if (previewwidth < calc_previewwidth){
					previewheight = calc_previewheight;
				}

				this.previewwidth  = previewwidth;
				this.previewheight = previewheight;
			}

			if(!this.disabled) {
				this.canChangeTitle = this.canChangeTitle == 'true' || this.canChangeTitle == '1' ? true : false;
				this.canDelete = this.canDelete == 'true' || this.canDelete == '1' ? true : false;
				this.canOpen = this.canOpen == 'true' || this.canOpen == '1' ? true : false;
			}

			var extension=this.extension.toLowerCase().replace(/^\./,"");
			if(extension == 'jpg' || extension == 'gif' || extension == 'png' || extension == 'bmp' ||
				 extension == 'tif' || extension == 'ico' || extension == 'swf' || extension == 'pdf' ||
				 extension == 'htm' || extension == 'html'|| extension == 'css' || extension == 'txt'){
				this.canOpen=true;
			}

			if(!epages.vars.BaseUrl) {
				console.warn("epages.vars.BaseUrl not defined in "+this.declaredClass);
			}
		},

		pathFromSite: function() {
			if(epages.vars.SiteRoot!== undefined) {
				return this.fullpath.replace(epages.vars.SiteRoot+"/", "");
			} else {
				return null;
			}
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);

			if (this.nodePixel !== undefined && (this.imagewidth == '' || this.imagewidth == null)){
				this.nodePixel.style.display = 'none';
			}
			if (this.nodeSize !== undefined && (this.size == '' || this.size == null)){
				this.nodeSize.style.display = 'none';
			}

			if(! this.disabled) {
				if (this.canChangeTitle) {
					this.connect(this.domNode,        'ondblclick', '_selectTitle');
					this.connect(this.nodeTitle,      'onclick', '_selectTitle');
					this.connect(this.nodeInputTitle, 'onchange', '_changeTitle');
					this.connect(this.nodeInputTitle, 'onkeydown', '_onKeyDown');
					this.connect(this.nodeInputTitle, 'onkeyup', '_onKeyUp');
					this.connect(this.nodeInputTitle, 'onblur', '_selectItem');
				}
			} else {
				this.domNode.removeChild(this.actionButtonsNode);
				dojo.addClass(this.domNode, "Disabled ToolTipCursor");
				// hide alt+title image tags
				//  this.nodeImage.removeAttribute('alt');
				//  this.nodeImage.removeAttribute('title');
				// show info tooltop
				
				var toolTipNode = document.createElement('tt');
				var toolTipText = document.createElement('div');
				toolTipText.innerHTML = '<strong>'+this.translate('UnsupportedFileFormat')+'</strong>';
				toolTipNode.appendChild(toolTipText);
				this.domNode.appendChild(toolTipNode);

				var toolTipWidget = new epages.widget.Tooltip({
     			tooltipArea: this.domNode,
     			interactive: true,
     			forceOrientation: 'B',
     			'class' : 'Wide'
    		}, toolTipNode);
			}
		},

		_selectTitle: function(){
			this.nodeTitle.style.display="none";
			this.nodeInputTitle.style.display="block";
			this.nodeInputTitle.value = this.nodeTitle.firstChild.nodeValue;
			this.nodeInputTitle.focus();
		},

		_changeTitle: function(){
			var me = this;
			if(this.store){
				if(this.nodeInputTitle.value != ''){
					var newName = this.store.renameFile(this.directory,this.path,this.nodeInputTitle.value);
					if(newName != false) {
						this.nodeTitle.firstChild.nodeValue = newName;
						this.path = this.path.replace((new RegExp(dojo.regexp.escapeString(this.name) + '$')),newName);
						this.fullpath = this.fullpath.replace((new RegExp(dojo.regexp.escapeString(this.name) + '$')),newName);
						this.name = newName;
						// remove error class
						dojo.removeClass(this.nodeInputTitle,"DialogError");
						dojo.removeClass(this.nodeTitle,"DialogError");
						// toggle to text label
						this._selectItem();
						//this.nodeInputTitle.style.display="none";
						//this.nodeTitle.style.display="block";
					} else {
						// error case, fill the string the user entered back into the input
						this.nodeTitle.firstChild.nodeValue = this.nodeInputTitle.value;
						// add error class
						dojo.addClass(this.nodeInputTitle,"DialogError");
						dojo.addClass(this.nodeTitle,"DialogError");
						// toggle to edit box
						this._selectTitle();
					}
				}
			}
		},

		_selectItem: function(){
			this.nodeInputTitle.style.display="none";
			this.nodeTitle.style.display="block";
		},

		_onKeyDown: function(evt) {
			// on enter switch title input with title span, like blur
			if(this.nodeInputTitle.value == '') {
				dojo.addClass(this.nodeInputTitle,"DialogError");
			}else{
				this._updateNodeInputTitle();
				if (evt.keyCode == 13) {
					this._selectItem();
				}
			}
		},

		_onKeyUp: function(evt) {
			this._updateNodeInputTitle();
		},

		_onDownload: function () {
			var TargetFile = this.store.removeMediaGalleryFromString(this.path);
			window.open(epages.vars.BaseUrl+'?ObjectID='+this.siteId+'&ViewAction=View&ChangeAction=ActionDownloadFile&File='+TargetFile,'Download');
		},

		_updateNodeInputTitle: function() {
			if(epages.Browser.engine === "MSIE") {
				this.nodeInputTitle.className += "";
			}
		}
	}
);

}

if(!dojo._hasResource["epages.widget.Dialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Dialog"] = true;
/*
Copyright (c) 2006-2007, ePages GmbH
All Rights Reserved.

epages.widget.Dialog $Revision: 1.10 $

*/
dojo.provide("epages.widget.Dialog");



dojo.declare(
"epages.widget.Dialog",
	[dijit.Dialog], {
		duration: epages.Browser.engine=="MSIE" ? 10 : 150,

		templateString:
			'<div class="dijitDialog ModalDialog" tabindex="-1">' +
					'<div dojoAttachPoint="titleBar" class="dijitDialogTitleBar" waiRole="dialog">' +
						'<span dojoAttachPoint="titleNode" class="dijitDialogTitle">${title}</span>' +
						'<span dojoAttachPoint="closeButtonNode" class="dijitDialogCloseIcon"  dojoAttachEvent="onclick: onCancel">' +
							'<span dojoAttachPoint="closeText" class="closeText">x</span>' +
						'</span>' +
					'</div>' +
					'<div class="LayerContent Border White">' +
						'<div dojoAttachPoint="containerNode" class="dijitDialogPaneContent"></div>' +
						'<div dojoAttachPoint="innerButtonBarNode" class="LayerInnerButtonBar" style="display:none"></div>' +
					'</div>' +
					'<div dojoAttachPoint="buttonBarNode" class="LayerButtonBar" style="display:none"></div>' +
			'</div>',


		postCreate: function() {
			this.inherited("postCreate",arguments);

			// hack to overlay applets
			if(epages.Browser.engine=="MSIE") {
				this.underlayIframe = document.createElement("iframe");
				this.underlayIframe.className="LayerIframe";
				this.underlayIframe.frameBorder="0";
				this.underlayIframe.src = "javascript:''";
			}
		},

		hide: function() {
			this.inherited("hide", arguments);
			if(epages.Browser.engine=="MSIE") {	// layer display corrections
				this.domNode.style.width="auto";
			}
		},

		show: function() {
			this.inherited("show", arguments);
			if(epages.Browser.engine=="MSIE") {	// layer display corrections
				this.domNode.style.width=this.domNode.offsetWidth+"px";
				this.domNode.style.overflow='hidden';
			}
			if(this.domNode && epages.zIndex){
				this.domNode.style.zIndex = epages.zIndex;
			}
			if(this._underlay){
				this._underlay.domNode.style.zIndex = this.domNode.style.zIndex-1;
			}
			if(epages.zIndex){
				epages.zIndex+=2;
			}
			//check if there is enough space to see the close button
			var popupTop = parseInt(this.domNode.style.top);
			var popupLeft = parseInt(this.domNode.style.left);
			if(popupTop < 0){
				this.domNode.style.top = "0px";
			}
			if(popupLeft < 0){
				this.domNode.style.left = "";
				this.domNode.style.right = "0px";
			}
			else {
				this.domNode.style.right = "";
			}
			//remove dragging
			if(this._moveable){
				this._moveable.destroy();
			}
		},

		_setup: function() {
			this.inherited("_setup", arguments);
			if(this._underlay){
				if(epages.Browser.engine=="MSIE") {
					this._underlay.node.appendChild(this.underlayIframe);
				} else {
					this._underlay.domNode.style.overflow= "auto"; // hack to overlay applets in ff
				}
			}
		}
	}
);



}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Filebrowser"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Filebrowser"] = true;
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Filebrowser");


epages.require('ep_shop_tree', 'epages.cartridges.de_epages.mediagallery.widget.Imagedbtree');









epages.require('ep_shop_upload', 'epages.uploader');

(function(jq){

	var jqUploaderReady = !1,
		jqUploaderCreate = function( self, data, exists, callback ){
			de_epages(self.uploadNode)
				.presentationUiUploader({
					data:		data,
					exists:		exists,
					big:		true,
					multiple:	true,
					callback:	callback
				});
		};

	dojo.declare (
		"epages.cartridges.de_epages.mediagallery.widget.Filebrowser",
		[epages.widget.LocalizedWidget],
		{
			/**
			 * public properties
			 */
			siteId          : epages.vars.SiteID,		// Integer - epages SiteID
			url             : '?',						// String - request url
			directory       : 'MediaGallery',			// String - base directory
			multiSelect     : 'true',					// String - multi item selection on or off
			validFileTypes  : '',						// String - show only files with these extensions
			imageDB         : epages.vars.ImageDbRoot,	// String - url to image database
			cssClass        : '',						// String - additional css classes
			opener          : '',						// String - define from where it was opend, is passed to the plugins

			multiSelectString   : "", 					// String - save multiSelect as string ("true" or "false")
			_fileStore          : undefined,			// Object - reference to file store
			_eventHandles       : undefined,			// Object[]- save event connects temporary for oneLineValueNode in this array
			_plugins            : {},					// save loaded plugins and depending nodes
			_visibleLeftBar     : undefined,
			_visibleContent     : undefined,
			_currentActivePlugin: undefined,

			galleryUsage        : {},               // hash with gallery size usage data

			/**
			 * dojo widget properties
			 */

			templateString:"<div class=\"Filebrowser ${cssClass}\">\n  <table class=\"FormGrid\" style=\"width:auto\"><tr>\n  <td class=\"LeftBar\" >\n    <div class=\"Container\" dojoAttachPoint=\"LeftBarContainerNode\">\n      <div class=\"FileTree\">\n        <div dojotype=\"epages.cartridges.de_epages.mediagallery.widget.Filestore\"\n          dojoAttachPoint=\"fileStoreWidget\"\n          jsId=\"${id}Filestore\"\n          url=\"${url}\"\n          id=\"${id}Filestore\"\n          validFileTypes=\"${validFileTypes}\"\n          siteId=\"${siteId}\"></div>\n        <div dojoType=\"dijit.tree.ForestStoreModel\" jsId=\"${id}Filemodel\"\n            store=\"${id}Filestore\" query=\"{id:'${directory}'}\"\n            rootLabel=\"{MediaGallery}\" childrenAttrs=\"children\"></div>\n        <div dojoType=\"epages.cartridges.de_epages.mediagallery.widget.Filetree\"\n             dojoAttachPoint=\"fileTreeWidget\"\n             label=\"{MediaGallery}\"\n             id=\"${id}Filetree\"\n             model=\"${id}Filemodel\"\n             listId=\"${id}Filelist\"\n             directory=\"${directory}\"\n             query=\"{id:'${directory}'}\"\n             ></div>\n        <div dojoAttachPoint=\"PluginLinksNode\">\n          <div dojoAttachPoint=\"selectImageDbNode\" style=\"cursor:pointer;\"><i class=\"Sprite object_ico_s_imagegallery\"></i>{ImageDb}</div>\n        </div>\n      </div>\n      <div class=\"Actions\">\n        <div class=\"Body\">\n          <div>\n            <div class=\"DoActionLink EnableHover\" dojoAttachPoint=\"newFolderButtonNode\" style=\"display:none\">{NewFolder}</div>\n            <div class=\"DoActionLink EnableHover\" dojoAttachPoint=\"renameFolderButtonNode\" style=\"display:none\">{RenameFolder}</div>\n            <div class=\"DoActionLink EnableHover\" dojoAttachPoint=\"deleteFolderButtonNode\" style=\"display:none\">{DeleteFolder}</div>\n          </div>\n\n          <div dojoAttachPoint=\"oneLineFormNode\" style=\"display:none;padding-top:1px;\" class=\"OnLineFormNode\">\n            <div dojoAttachPoint=\"oneLineTextNode\"></div>\n            <div style=\"height:25px; position: relative\">\n              <input class=\"BottomMargin\" dojoAttachPoint=\"oneLineValueNode\"  type=\"text\"   name=\"value\"  value=\"\" />\n            </div>\n            <span class=\"Button FloatLeft RightMargin\" dojoAttachPoint=\"oneLineSaveNode\"><span class=\"ButtonContainer\">{Save}</span></span>\n            <span class=\"Button FloatLeft\" dojoAttachPoint=\"oneLineCancelNode\"          ><span class=\"ButtonContainer\">{Cancel}</span></span>\n          </div>\n        </div>\n      </div>\n      <div class=\"ImageDb\" dojoAttachPoint=\"imageDbAreaNode\">\n        <div dojoAttachPoint=\"selectMediagalleryNode\" style=\"cursor:pointer;\"><i class=\"Sprite ico_s_folder\"></i>{MediaGallery}</div>\n        <div dojotype=\"epages.cartridges.de_epages.mediagallery.widget.Imagedbstore\"\n          jsId=\"${id}Imagedbstore\"\n          id=\"${id}Imagedbstore\"\n          ></div>\n        <div dojotype=\"epages.cartridges.de_epages.mediagallery.widget.Imagedbtree\"\n          dojoAttachPoint=\"imagedbTreeWidget\"\n          id=\"${id}Imagedbtree\"\n          store=\"${id}Imagedbstore\"\n          label=\"{ImageDb}\"\n          listId=\"${id}Filelist\"\n          ></div>\n      </div>\n\n  </td>\n  <td class=\"MainBar\">\n    <div class=\"Container\" dojoAttachPoint=\"ContentNode\">\n      <div class=\"FileList\">\n        <div dojoAttachPoint=\"currentDirectoryNode\" class=\"CurrentDirectory\">{MediaGallery}</div>\n        <div dojoType=\"epages.widget.Elementlist\"\n          dojoAttachPoint=\"fileListWidget\"\n          id=\"${id}Filelist\"\n          store=\"${id}Filestore\"\n          widgetElementType=\"epages.cartridges.de_epages.mediagallery.widget.Filelistitem\"\n          multiSelect=\"${multiSelectString}\"\n          pagging=\"true\"\n          ></div>\n        <div class=\"ClearBoth\"></div>\n        <div dojoAttachPoint=\"MultiselectTipNode\" style=\"padding: 6px; display:none\"><div class=\"DialogMessageSmall MessageTip\">{MultiSelect}</div></div>\n      </div>\n      <div class=\"ActionsBar Upload\">\n        <div class=\"Body\">\n          <input type=\"file\" size=\"1\" class=\"NoButtonTrigger\" dojoAttachpoint=\"uploadNode\" id=\"${id}Upload\"/>\n            <a class=\"CommandLinkSmall LeftMargin\" dojoAttachPoint=\"deleteFilesNode\" unselectable=\"on\"\n               onclick=\"return false\" href=\"javascript: void(0);\"\n               ><span><span class=\"WithIcon Delete\">{DeleteFiles}</span></span></a>\n            <span dojoAttachPoint=\"imageDbActionsNode\" style=\"display:none; padding: 6px 0;\">\n              <span><span class=\"Button Active EnableHover\" dojoAttachPoint=\"copyDBImagesNode\"  ><span class=\"ButtonContainer\" dojoAttachPoint=\"copyDBImagesLabelNode\" >{CopyImages}</span></span></span>\n              <span class=\"CopyToTargetInfo\" style=\"display:inline\"><span style=\"display:block; display: inline-block\">({CopyToTarget}: <span dojoAttachPoint=\"copyToTargetNode\">{MediaGallery}</span>)</span></span>\n            </span>\n          </div>\n        </div>\n      </div>\n    </div>\n  </td></tr>\n  </table>\n</div>\n",
			translationName  : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget','templates/translation'),
			widgetsInTemplate:true,

			/**
			 * widget life cycle
			 */

			postMixInProperties: function() {
			// summary: initalize values - adjust properites
				this.inherited("postMixInProperties", arguments);
				this.multiSelect = epages.string.toBoolean(this.multiSelect);
				this.multiSelectString = this.multiSelect ? "true" : "false";
			},

			setFileTypes: function(/* String */ fileTypes) {
				if(typeof(fileTypes) === "string" && (this.validFileTypes != fileTypes)) {
					this.validFileTypes = fileTypes;
					this._fileStore.setFileTypes(this.validFileTypes);
					this.fileTreeWidget.reloadFiles();
				}
			},

			postCreate: function() {
			// summary: initalize widget - append events, adjust properites
				this.inherited("postCreate", arguments);

				this._appendEvents();

				this._fileStore = (eval(this.id+'Filestore'));
				this._eventHandles = [];

				// gallery usage updater
				this.galleryUsage = this._fileStore.galleryUsage;

				// action event for upload button
				this._changeUploader();

				//register and build plugin connections
				this._registerPlugins();

				//### DEBUG ###

				//### DEBUG ###
			},

			startup: function() {
			// summary: load files of base folder
				this.inherited("startup", arguments);
				this.openRootFolder();
			},

			_appendEvents: function() {
			// summary: register events and subscriptions

				// register events
				this.connect(this.newFolderButtonNode, 'onclick', '_OnNewFolder');
				this.connect(this.renameFolderButtonNode, 'onclick', '_OnRenameFolder');
				this.connect(this.deleteFolderButtonNode, 'onclick', '_OnDeleteFolder');
				this.connect(this.deleteFilesNode, 'onclick', '_OnDeleteFiles');
				this.connect(this.copyDBImagesNode, 'onclick', '_OnCopyFilesFromDB');
				this.connect(this.oneLineValueNode,'onchange', '_removeDialogErrorLineValueNode');
				this.connect(this.oneLineValueNode,'onkeyup', '_removeDialogErrorLineValueNode');
				this.connect(this.selectImageDbNode,'onclick', '_showImageDb');
				this.connect(this.selectMediagalleryNode,'onclick', '_showMediagallery');


				// subscriptions
				dojo.subscribe(this.uploadNode.id + '/onUploadFinished', this, '_OnUploadFinish');	// upload finished
				dojo.subscribe(this.fileTreeWidget.id + '/select', this, '_OnSelectFileTree');				// directory selected
				dojo.subscribe(this.imagedbTreeWidget.id + '/select', this, '_OnSelectDB');						// imagedb directory selected
				dojo.subscribe(this.fileListWidget.id + '/select', this, '_OnSelectFileList');				// file in file list selected
				dojo.subscribe(this.id + 'Filelist/afterSetChildren', this, "_onFileListCreated");		// items in filelist ready
				dojo.subscribe(this.fileListWidget.store.id + '/onError', this, '_OnError');					// error in file store
				dojo.subscribe(this.fileListWidget.store.id + '/onSuccess', this, '_OnSuccess');			// fixed error in file store

				dojo.subscribe(this.fileListWidget.store.id + '/updateCurrentBytes', this, function(kilobytes) {
					dojo.publish(this.id+'/updateCurrentBytes', [kilobytes]);
				});

				dojo.subscribe('Filebrowser/showMediagallery',this,'showMediagallery');
				dojo.subscribe('Filebrowser/showMediagalleryContent',this,'showMediagalleryContent');
				dojo.subscribe('Filebrowser/showMediagalleryLeftBox',this,'showMediagalleryLeftBox');
			},

			/**
			 * getter, setter and other public functions
			 */

			openRootFolder: function() {
			// summary: simulate click on root node
				this.fileTreeWidget.onClick(this.fileTreeWidget.rootNode.item, this.fileTreeWidget.rootNode);
			},

			getSelectedItems : function() {
			// summary: get selected items
			// returns: selected items of file list
				return $$(this.id + 'Filelist').selectedNodes();
			},

			/**
			 * events and subscriptions
			 */

			_onFileListCreated: function(/* object */ opt) {
			// summary: attach button events to file items
			// opt: { source: this, length: elements.length }

				for( var i=0,iLength=opt.length ; i<iLength ; i++ ) {
					var curChild = opt.source.children[i];

					// attach delete button event
					if(curChild.canDelete && curChild.deleteNode) {
						this.connect(curChild.deleteNode, "onclick", "_OnDeleteFilesInline");
						curChild.deleteNode.style.display="";
					}

					// attach download button event
					if(curChild.downloadNode) {
						dojo.connect(curChild.downloadNode, "onmouseup", curChild, "_onDownload");

						curChild.downloadNode.style.display="";
						curChild.downloadNode.href=curChild.fullpath;
						curChild.downloadNode.onclick=function() {
							return false;
						};
					}
				}
			},

			_removeDialogErrorLineValueNode: function(){
			// summary: event function (keyup change, oneLineValueNode) -remove css error class and error message from onLineValueNode
				dojo.publish("uimessage/hide");
				dojo.removeClass(this.oneLineValueNode,'DialogError');
			},

			/**
			* widget button/ display functions
			*/

			_replaceDirectoryName: function(/* string */ directoryName) {
			// summary: replaces "MediaGallery" and "ImageDb" with translations
				if(directoryName) {
					directoryName=directoryName.replace(/^MediaGallery/, this.translate("MediaGallery"));
					directoryName=directoryName.replace(/^ImageDb/, this.translate("ImageDb"));
				}
				return directoryName;
			},

			_setCurrentDirectory: function(/* object */ opt) {
			// summary: updates the currentDirectoryNode (insert current directory)
				var directoryName = this._replaceDirectoryName(opt.currentDirectory);
				if(directoryName){
					this.currentDirectoryNode.firstChild.data = directoryName;
				}
				else{
					this.currentDirectoryNode.firstChild.data = this.translate("MediaGallery");
				}
			},

			_showImageDb: function() {
				dojo.fx.slideTo({ node: this.imageDbAreaNode, left:"0", top:"0", unit:"px" }).play();
				this._visibleLeftBar = this.imageDbAreaNode;
				this._currentActivePlugin = 'ImageDB';
			},

			_showMediagallery: function() {
				if(this._currentActivePlugin){
					this._currentActivePlugin = undefined;
				}
				if(this._visibleLeftBar){
					dojo.fx.slideTo({ node: this._visibleLeftBar, left:"-230", top:"0", unit:"px" }).play();
				}
				this.openRootFolder();
			},
			_showMediagalleryContent: function(){
				if(this._currentActivePlugin){
					this._currentActivePlugin = undefined;
				}
				if(this._visibleContent){
					dojo.fx.slideTo({ node: this._visibleContent, left:"680", top:"0", unit:"px" }).play();
				}
			},

			showMediagallery: function(){
				this._showMediagallery();
				this._showMediagalleryContent();
			},

			showMediagalleryLeftBox: function(){
				this._showMediagallery();
			},

			showMediagalleryContent: function(){
				this._showMediagalleryContent();
			},

			changeOpener: function(opener){
				this.opener = opener;
				dojo.publish('Filebrowser/changeOpener',[opener]);
			},

			_selectFileByName: function(fileName){
				var selectedFile;
				var fileListChildren = this.fileListWidget.children;
				for (var i = 0, l = fileListChildren.length; i < l; i++) {
					if (fileListChildren[i].name == fileName){
						selectedFile = fileListChildren[i];
						break;
					}
				}
				this.fileListWidget.select(selectedFile);
			},

			/**
			* file / folder operations
			*/

			/*  --- NEW FOLDER --- */
			_OnCancelSingleDialog: function (/* event */ evt) {
			// summary: reset function of oneLineValueNode
			// description: resets value, hides the node and removes all connected events
				this.oneLineFormNode.style.display="none";
				this.oneLineValueNode.value="";
				this.newFolderButtonNode.parentNode.style.display="";
				for( var i=0,iLength=this._eventHandles.length ; i<iLength ; i++ ){
					dojo.disconnect(this._eventHandles[i]);
				}
				this._eventHandles = [];
			},

			_OnSaveNewFolder: function(/* event */ evt) {
			// summary: creates a new directory
				if(this.oneLineValueNode.value == ''){
					this._showErrorBubble(this.translate('InsertNewFolderName'));
				} else {
					if(this.fileTreeWidget.createDirectory(this.oneLineValueNode.value) == true) {
						// show buttons, close dialog
						this._OnCancelSingleDialog(evt);
					}
				}
			},

			_OnNewFolderKeyUp: function(/* event */ evt) {
			// summary: event function (keyup, oneLineFormNode) - trigger save function if enter key was pressed
				if(evt.keyCode == 13) {		// enter pressed
					this._OnSaveNewFolder(evt);
				}
			},

			_OnNewFolder: function(/* event */ evt) {
			// summary: event function (onclick, newFolderButtonNode) - initalize elements of "oneLineForm" (form to create a new folder)
				var directory = this.fileTreeWidget.getCurrentDirectory();
				if (directory === undefined) {
					console.warn('_OnNewFolder() -> directory undefined in '+this.declaredClass);
				} else {
					this.newFolderButtonNode.parentNode.style.display="none";
					this.oneLineFormNode.style.display="";
					this.oneLineTextNode.innerHTML=this.translate('NewFolder');
					this.oneLineValueNode.focus();
					this._eventHandles.push(dojo.connect(this.oneLineFormNode,   'onkeyup', this, '_OnNewFolderKeyUp'));
					this._eventHandles.push(dojo.connect(this.oneLineSaveNode,   'onclick', this, '_OnSaveNewFolder'));
					this._eventHandles.push(dojo.connect(this.oneLineCancelNode, 'onclick', this, '_OnCancelSingleDialog'));
				}
			},

			/*  --- DELETE FOLDER --- */
			_OnDeleteFolder: function (/* event */ evt) {
			// summary: event function (click, deleteFolderButtonNode) - delete current directory
				var directory = this.fileTreeWidget.getCurrentDirectory();
				if (directory === undefined) {
					console.warn('_OnDeleteFolder() -> directory undefined in '+this.declaredClass);
				} else {
					var folderName = this.fileTreeWidget.getCurrentDirectoryName();
					// show confirmation message
					
					dojo.publish("uimessage/show", [
						this.translate("HeadLineDeleteFolder"),
						this.translate("DeleteFolderAndSubFolder")+" <br />"+this.translate("SelectedFolder") + ': ' + folderName, 'Dialog', {
							titleBar:  this.translate("DeleteFolder"),
							sizeClass: 'Large',
							typeClass: 'Confirmation',
							onYes:     dojo.hitch(this, function() {
								this.fileTreeWidget.deleteDirectory(directory);
							})
						}]);
				}
			},

			/*  --- RENAME FOLDER --- */
			_OnSaveRenameFolder: function (/* event */ evt) {
			// summary: event function (click, renameFolderButtonNode) - rename current directory
				// save
				if(this.fileTreeWidget.renameDirectory(this.oneLineValueNode.value) == true) {
					// show buttons, close dialog
					this._OnCancelSingleDialog(evt);
				}
			},

			_OnRenameFolderKeyUp: function(/* event */ evt) {
			// summary: event function (keyup, oneLineFormNode) - trigger save function if enter key was pressed
				if(evt.keyCode == 13) {
					this._OnSaveRenameFolder(evt);
				}
			},

			_OnRenameFolder: function (/* event */ evt) {
			// summary: event function (click, renameFolderButtonNode) - initalize elements of "oneLineForm" (form to rename current folder)
				var directory = this.fileTreeWidget.getCurrentDirectory();
				if (directory === undefined) {
					console.warn('_OnRenameFolder() -> directory undefined in '+this.declaredClass);
				} else {
					var node = this.fileTreeWidget.getLastSelectedNode();
					this.newFolderButtonNode.parentNode.style.display="none";
					this.oneLineFormNode.style.display="";
					this.oneLineTextNode.innerHTML=this.translate('RenameFolder');
					this.oneLineValueNode.value = node.labelNode.innerHTML;
					this.oneLineValueNode.focus();
					this._eventHandles.push(dojo.connect(this.oneLineFormNode,   'onkeyup', this, '_OnRenameFolderKeyUp'));
					this._eventHandles.push(dojo.connect(this.oneLineSaveNode,   'onclick', this, '_OnSaveRenameFolder'));
					this._eventHandles.push(dojo.connect(this.oneLineCancelNode, 'onclick', this, '_OnCancelSingleDialog'));
				}
			},


			/*  --- COPY FILES FROM DB TO MediaGallery --- */
			_OnCopyFilesFromDB: function (/* event */ evt) {
			// summary: event function (click, copyDBImagesNode) - copies selected files to last selected dir in mediagallery
				var directory = this.fileTreeWidget.getCurrentDirectory();
				if (directory === undefined) {
						alert(this.translate('NoDirectorySelected'));
				} else {
					var files = this.fileListWidget.selectedItems();
					if (files.length > 0) {
						this._fileStore.copyImageFromImageDb(directory, files);
						var treeNodeWidget =this.fileTreeWidget.getLastSelectedNode();
						epages.event.fire(treeNodeWidget.domNode, "click");
						this._showMediagallery();
						//select last copied image
						for(var i = 0, l = files.length; i < l; i++){
							var currentFile = files[i];
							var currentFileName = currentFile.substring(currentFile.lastIndexOf("/")+1);
							//select file in current Filelist
							this._selectFileByName(currentFileName);
						}
					} else {
						dojo.publish("uimessage/show", [ this.translate('NoFilesSelected'), this.translate('DoSelectFiles'), 'Dialog', {
								titleBar: this.translate('FileRepository')+" &ndash; "+this.translate('Notification'),
								typeClass: 'Notification'
							}
						]);
					}
				}
			},

			_OnDeleteFilesInline: function(evt) {
			// summary: display confirmation dialog

					// look up filename
					var srcNode = evt.currentTarget;
					var node = srcNode;
					while(!node.getAttribute("widgetid") && node.parentNode !== undefined) {
						node = node.parentNode;
					}

					var fileName = "";
					var widgetId = undefined;

					if(node) {
						widgetId = node.getAttribute("widgetid");
					}
					if(widgetId) {
						var fileWidget = $$(widgetId);

						// show confirmation message
						
						dojo.publish("uimessage/show", [
							this.translate("HeadLineDeleteFile"),
							this.translate("File") + ': ' + fileWidget.name, 'Dialog', {
								titleBar:  this.translate("TitleDeleteFile"),
								sizeClass: 'Large',
								typeClass: 'Confirmation',
								onYes:     dojo.hitch(this, function() {
									this.fileTreeWidget.deleteFiles();
								})
						}]);
					}
			},

			_OnDeleteFiles: function() {
			// summary: delete current selected files
				// lookup filenames
				var fileNames = $A([]);
				var deleteTotalSize = 0;
				$A(this.fileListWidget.selectedNodes()).each(function(el) {
					fileNames.push(el.name);
					deleteTotalSize += el.data.size;
				});
				// show confirmation message
				if(fileNames.length) {
					
					dojo.publish("uimessage/show", [
						this.translate("HeadLineDeleteFiles"),
						this.translate("Files") + ': ' + fileNames.join(', ') , 'Dialog', {
							titleBar:  this.translate("TitleDeleteFiles"),
							sizeClass: 'Large',
							typeClass: 'Confirmation',
							onYes:     dojo.hitch(this, function() {
								this.fileTreeWidget.deleteFiles();
							})
						}]);
					}
			},

			_changeUploader: function (params) {
				var self = this,
					exists = [],
					data = {
						ViewAction:			'JSONViewResponse',
						ChangeAction:		'UploadFilesToMediaGallery',
						ObjectID:			epages.vars.SiteID,
						handleashtml:		1,
						Directory:			(params && params.directory) ? params.directory : '/'
					},
					callback = function( data ){
						dojo.publish( self.uploadNode.id + '/onUploadFinished', [data] );
						// refresh uploader settings
						self._changeUploader(params);
					};
					
				dojo.forEach( this.fileListWidget._allChildren, function( file, i ){
					exists.push(file.name);
				});

				if( jqUploaderReady ){
						jqUploaderCreate( self, data, exists, callback );
				}
				else{
					jq.ready( 'de_epages.presentation.ui.uploader', function(){
						jqUploaderReady = !0;
						jqUploaderCreate( self, data, exists, callback );
					});
				}
			},

			/*  --- SELECT A TREE NODE --- */
			_OnSelectFileTree: function (/* Object */ opt) {
			// summary: sets the current directory and shows the right action links
			// opt: {node:node, currentDirectory: directory}
				opt.currentDirectory = this._fileStore.removeMediaGalleryFromString(opt.currentDirectory);
				//this.uploadWidget.setDirectory(opt.currentDirectory);
				this._changeUploader({ directory : opt.currentDirectory });
				this._setCurrentDirectory(opt);

				// show possible directory actions
				this.newFolderButtonNode.style.display="";
				this.deleteFilesNode.style.display="";
				var directory = this.fileTreeWidget.getCurrentDirectory();
				if (directory !== undefined && directory != this.directory) {
					this.renameFolderButtonNode.style.display="";
					this.deleteFolderButtonNode.style.display="";
				} else {
					this.renameFolderButtonNode.style.display="none";
					this.deleteFolderButtonNode.style.display="none";
				}

				// hide image db actions
				this.imageDbActionsNode.style.display="none";
				this.uploadNode.style.display="";
				this.copyToTargetNode.firstChild.data = this._replaceDirectoryName(directory);

				// publish event
				dojo.publish(this.id+'/fileTreeNodeSelected', []);

				this._updateMultiselectTip();
			},

			_OnSelectDB: function (opt) {
			// summary: sets the current image db directory and shows the right action links
				this._setCurrentDirectory(opt);

				// hide directory actions
				this.newFolderButtonNode.style.display="none";
				this.renameFolderButtonNode.style.display="none";
				this.deleteFolderButtonNode.style.display="none";
				this.deleteFilesNode.style.display="none";

				// adjust copy button
				if(epages.Browser.engine == "Gecko") {
					this.imageDbActionsNode.style.display="inline";
				}else {
					this.imageDbActionsNode.style.display="";
				}

				// hide upload widget
				this.uploadNode.style.display="none";

				// publish event
				dojo.publish(this.id+'/imageDBSelected', []);

				this._updateMultiselectTip();
			},

			_updateMultiselectTip : function() {
				// summary: show or hide multi select hint
				if(this.multiSelect && this.fileListWidget.children.length > 1) {
					this.MultiselectTipNode.style.display="";
				} else {
					this.MultiselectTipNode.style.display="none";
				}
			},

			_OnSelectFileList: function(opt){
			// summary: subscription to fileListWidget - publish that files
				var tooMuchItemsSelected = (this.multiSelect == false && this.fileListWidget.selectedNodes().length > 1);
				dojo.publish(this.id+'/filesSelected', [tooMuchItemsSelected]);
			},

			_OnUploadFinish: function (/* object*/opt){
			// summary: subscription to upload widget (upload finished) - refresh file list
			// opt: { result: this._filesUploaded }
				var directory = this.fileTreeWidget.getCurrentDirectory();
				this._fileStore.resetDirectory(directory);
				this.fileTreeWidget.reloadFiles();

				if(opt.length > 0) {
					var lastItem = opt[opt.length-1];
					if(lastItem && lastItem.success && lastItem.success.currentGallerySize) {
						dojo.publish(this.id+'/updateCurrentBytes', [lastItem.success.currentGallerySize]);
					}
				}
			},

			_OnError: function(errorData) {
			// summary: subscription to file store widget - display errors
			// errorData: {Errors: JsonData.error.data.Errors}
				for( var i=0,iLength=errorData.Errors.length ; i<iLength ; i++ ) {
					if(errorData.Errors[i].Reason == 'DirectoryAlreadyExists') {
						this._showErrorBubble(this.translate('DirectoryAlreadyExists'));
					}
					else if(errorData.Errors[i].Reason == 'FileAlreadyExists') {
						this._showErrorBubble(this.translate('FileAlreadyExists'), 'store');
					}
					else if(errorData.Errors[i].Reason == 'GeneralDirectoryCreateError') {
						this._showErrorBubble(this.translate('GeneralDirectoryCreateError'));
					}
				}
			},

			_OnSuccess: function(callerData) {
			// summary: hides the error bubble
			// description:
			//   An action resulted in an error in the first place. A second
			//   user action then leads to success, so no more error should be indicated.
				this._hideErrorBubble();
			},

			_showErrorBubble: function(/* string */ captionText, /* string */ elementLocation) {
			// summary:
			//			shows an error bubble below oneLineValueNode
			// description:
			//			Displays an error bubble at the location of the error throwing dom element containing the
			//			given captionText. If the parameter elementLocation is set to 'store' the function displays
			//			the bubble for the file store - otherwise for the directory tree.

				// bubble in directory tree or in file store?
				var targetElement;
				if(elementLocation == 'store') {
					targetElement = this.getSelectedItems()[0].nodeTitle;
				}
				else {
					targetElement = this.oneLineValueNode;
				}

				var position = $E(targetElement).getAbsolutePosition();
				dojo.publish("uimessage/show", ["", captionText, "Bubble", {
					typeClass: "Warning",
					sizeClass: "Small",
					x: position.x,
					y: position.y + targetElement.offsetHeight
				}]);
				dojo.addClass(targetElement,'DialogError');
			},

			_hideErrorBubble: function(targetElement) {
				this._removeDialogErrorLineValueNode();
			},

			_registerPlugins: function(){
				var mediaGalleryPlugins = epages.vars.MediaGalleryPlugins;
				//check if plugins defined
				if(mediaGalleryPlugins && mediaGalleryPlugins.length){
					for(var i = 0,l = mediaGalleryPlugins.length; i < l;i++){
						var currentPlugin = mediaGalleryPlugins[i];
						//insert Plugin link to link section
						var linkNode = document.createElement('div');
						dojo.style(linkNode,'cursor','pointer');
						linkNode.innerHTML = '<img src="'+currentPlugin.link.iconSrc+'" />'+currentPlugin.link.title;
						this.PluginLinksNode.appendChild(linkNode);
						this.connect(linkNode,'onclick', function(){
							this._OnPluginLinkClick(currentPlugin.id);
						});

						//insert leftBarContainer with widget
						var leftBarPluginNode = document.createElement('div');
						leftBarPluginNode.innerHTML = currentPlugin.leftBarWidget;
						dojo.addClass(leftBarPluginNode,'PluginLeftBar');
						this.LeftBarContainerNode.appendChild(leftBarPluginNode);
						dojo.parser.parse(leftBarPluginNode);
						var mediagalleryNode = this.selectMediagalleryNode.cloneNode(true);
						this.connect(mediagalleryNode,'onclick', 'showMediagallery');
						leftBarPluginNode.insertBefore(mediagalleryNode,leftBarPluginNode.firstChild);

						//insert mainContainer with widget
						var contentPluginNode = document.createElement('div');
						contentPluginNode.innerHTML = currentPlugin.contentWidget;
						dojo.addClass(contentPluginNode,'PluginContent');
						this.ContentNode.appendChild(contentPluginNode);
						dojo.parser.parse(contentPluginNode);


						this._plugins[currentPlugin.id] = {
							'pluginData': currentPlugin,
							'linkNode': linkNode,
							'linkNodeOnClickConnect':'',
							'leftBarNode':leftBarPluginNode,
							'contentNode': contentPluginNode
						};
					}
				}
			},

			_OnPluginLinkClick:function(pluginId){
				if(this._plugins[pluginId]){
					var currentPlugin = this._plugins[pluginId];
					dojo.fx.slideTo({ node: currentPlugin.leftBarNode, left:"0", top:"0", unit:"px" }).play();
					this._visibleLeftBar = currentPlugin.leftBarNode;
					dojo.fx.slideTo({ node: currentPlugin.contentNode, left:"0", top:"0", unit:"px" }).play();
					this._visibleContent = currentPlugin.contentNode;
					dojo.publish('Filebrowser/PluginLinkClick',[{id: pluginId,opener: this.opener}]);
					this._currentActivePlugin = pluginId;
				}
			},

			onApply: function(){
				dojo.publish('Filebrowser/onApply',[this._currentActivePlugin]);
				if(this._currentActivePlugin && this._currentActivePlugin == 'ImageDB'){
					//when ImageDB is activated check if there are files selected and copy them to own images and insert them
					if(this.getSelectedItems()){
						this._OnCopyFilesFromDB();
					}
				}
			},

			pluginActive:function(){
				if(this._currentActivePlugin){
					return this._currentActivePlugin;
				}
				else{
					return false;
				}
			}
		}
	);

})(jQuery);

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Mediagallery"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Mediagallery"] = true;
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Mediagallery");









dojo.declare (
	"epages.cartridges.de_epages.mediagallery.widget.Mediagallery",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		onApply         : '',					// onApply function
		applyButtonLabel: '',					// label of apply button

		// pass properties to filebrowser widget
		siteId          : epages.vars.SiteID,				// epages SiteID
		url             : '?',											// request url
		directory       : 'MediaGallery',						// base directory
		multiSelect     : 'true',										// multi item selection on or off
		validFileTypes  : "",												// show only files with these file extensions
		imageDB         : epages.vars.ImageDbRoot,	// url to image database
		opener          : '',												// string to define from where it was opend, passed to the Filebrowser

		// pass properties to gallery size usage widget
		maxGallerySize      : '',
		currentGallerySize  : '',



		/**
		 * private properties
		 */
		_applyButtonDisabled: true,				// flag: indicates wether the apply button is disabled or not
		_applyButtonActive  : false,			// flag: indicates wether the apply button is active (highlighted) or not

		/**
		 * widget properties
		 */

		templateString:"<div>\n  <div dojoType=\"epages.widget.Dialog\"\n         dojoAttachpoint=\"dialogWidget\"\n         title=\"{FileRepository}\"\n         class=\"MediaGallery\">\n\n    <div dojoType=\"epages.cartridges.de_epages.mediagallery.widget.Filebrowser\"\n      dojoAttachPoint=\"fileBrowserWidget\"\n      siteId=\"${siteId}\"\n      id=\"${id}_Filebrowser\"\n      directory=\"MediaGallery\"\n      url=\"${url}\"\n      multiSelect=\"${multiSelect}\"\n      validFileTypes=\"${validFileTypes}\"\n      imageDB=\"${imageDB}\"\n      opener=\"${opener}\"\n    ></div>\n\n    <div dojoAttachPoint=\"buttonsNode\">\n      <div class=\"FloatLeft\"\n        dojoType=\"epages.cartridges.de_epages.mediagallery.widget.GallerySizeUsage\"\n        dojoAttachPoint=\"gallerySizeUsage\"\n        maxGallerySize=\"${currentGallerySize}\"\n        currentGallerySize=\"${currentGallerySize}\"\n      ></div>\n      <div class=\"FloatRight\">\n        <span class=\"Button Active EnableHover\" dojoAttachPoint=\"applyButtonNode\"  ><span class=\"ButtonContainer\" dojoAttachPoint=\"applyButtonLabelNode\" >{Apply}</span></span>\n        <span class=\"Button EnableHover\" dojoAttachPoint=\"cancelButtonNode\" ><span class=\"ButtonContainer\">{Close}</span></span>\n      </div>\n    </div>\n  </div>\n</div>\n",
		translationName  : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget','templates/translation'),
		widgetsInTemplate:true,

		/**
		 * widget life cycle
		 */
		postMixInProperties: function() {
		// summary: initalize values - adjust properites
			this.inherited("postMixInProperties", arguments);
		},

		postCreate: function() {
		// summary: initalize widget - append events, adjust properites
			this.inherited("postCreate", arguments);
			this.multiSelect = epages.string.toBoolean(this.multiSelect);
			this._appendEvents();
			this._initButtonBar();

			// remove the dialog title
			this.dialogWidget.titleBar.removeAttribute("title");

			// gallery usage updater
			this.gallerySizeUsage.updateUsage(this.fileBrowserWidget.galleryUsage);
		},

		_initButtonBar: function() {
		// summary: move buttons into dialog widget, init apply button
			if(this.applyButtonLabel !=""){
				this.applyButtonLabelNode.firstChild.data = this.applyButtonLabel;
			}
			if(dojo.hasClass(this.applyButtonNode,'Active')){
				this._applyButtonActive = true;
			}
			this._doDisableApplyButton(true);

			// move buttons into the Dialogs button bar
			this.dialogWidget.buttonBarNode.appendChild(this.buttonsNode);
			this.dialogWidget.buttonBarNode.style.display = "block";

			if (this.onApply == ''){
				this._hideApplyButton();
			}else{
				this._showApplyButton();
			}

			var bNode = this.buttonsNode; // silly workaround for msie (force rendering again)
			bNode.style.display="none";
			window.setTimeout(function() {bNode.style.display="block";}, 10);
		},

		_appendEvents: function() {
		// summary: append button events, subscribe to filetree and imagedb
			// events
			this.connect(this.applyButtonNode, 'onclick', '_OnApply');
			this.connect(this.cancelButtonNode, 'onclick', 'hide');

			// subscriptions
			dojo.subscribe(this.id+'_Filebrowser/fileTreeNodeSelected', this, '_enableApplyButton');			// on select folder -> show apply button
			//dojo.subscribe(this.id+'_Filebrowser/imageDBSelected', this, '_disableApplyButton');					// on select imageDB -> hide apply button
			dojo.subscribe('Mediagallery/hide',this,'hide');
			dojo.subscribe('Mediagallery/disableApplyButton',this,'_disableApplyButton');
			dojo.subscribe('Mediagallery/enableApplyButton',this,'_enableApplyButton');

			// propagate upload/delete/create events
			dojo.subscribe(this.id+'_Filebrowser/updateCurrentBytes', this, function(kilobytes) {
				dojo.publish(this.gallerySizeUsage.id+'/updateCurrentBytes', [kilobytes]);
			});
		},

		/**
		 * getter, setter and other public functions
		 */

		hide: function() {
		// summary: hide dialog widget
			this.dialogWidget.hide();
		},

		show: function() {
		// summary: show dialog widget
			this.dialogWidget.show();
		},

		changeOpener: function(opener){
			if(opener){
				this.opener = opener;
				this.fileBrowserWidget.changeOpener(opener);
			}
		},

		setOnApply: function(/* function */ onApply) {
		// summary: setter for onApply function
			if(onApply != '' && onApply != null && onApply !== undefined) {
				this.onApply=onApply;
				this._showApplyButton();
			} else {
				// reset on invalid onApply value
				this.onApply='';
				this._hideApplyButton();
			}
		},

		setFileTypes: function(/* String */ fileTypes) {
			// summary: updates the list of allowed file extensions
			if(typeof(fileTypes) === "string" && (this.validFileTypes != fileTypes)) {
				this.validFileTypes = fileTypes;
				this.fileBrowserWidget.setFileTypes(this.validFileTypes);
			}
		},

		/**
		* widget button/ display functions
		*/

		_showApplyButton: function() {
		// summary: show and enable apply button
			dojo.removeClass(this.applyButtonNode, "HideElementSoft");
			this._doDisableApplyButton(false);
		},

		_hideApplyButton: function() {
		// summary: hide and disable apply button
			dojo.addClass(this.applyButtonNode, "HideElementSoft");
			this._doDisableApplyButton(true);
		},

		_disableApplyButton: function() {
		// summary: disable apply button
			this._doDisableApplyButton(true);
		},

		_enableApplyButton: function() {
		// summary: enable apply button
			this._doDisableApplyButton(false);
		},

		_doDisableApplyButton: function(/* boolean */ doDisable) {
		// summary: disable or enable apply button
			this._applyButtonDisabled = doDisable;
			if(doDisable){
				dojo.addClass(this.applyButtonNode, "Disabled");
				if(this._applyButtonActive){ 
					dojo.removeClass(this.applyButtonNode, "Active");
				}
			} else {
				dojo.removeClass(this.applyButtonNode, "Disabled");
				if(this._applyButtonActive){ 
					dojo.addClass(this.applyButtonNode, "Active");
				}
			}
		},

		_OnApply: function(evt) {
		// summary: call callback function onApply and pass selected items
		//check if apply button is clicked while plugin is open

			if(!this._applyButtonDisabled) {
				this.fileBrowserWidget.onApply();
				if(this.fileBrowserWidget.pluginActive()){
					//if inside the filebrowser a plugin ist still active return and do nothing
					//plugin has to be deactivated or has to close the mediagallery
					return;
				}
				this.dialogWidget.hide();
				var items = this.fileBrowserWidget.getSelectedItems();
				//only do custom onApply if now plugin is active inside filebrowser
				if (typeof(this.onApply) == 'function') {
					this.onApply(items);
				} else {
				 console.warn("Invalid function passed to onApply in "+this.declaredClass);
				}
			}
		}

});

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.Mimetypehtml"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.Mimetypehtml"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.Mimetypehtml $Revision: 1.5.2.1 $

*/

dojo.provide("epages.cartridges.de_epages.mediagallery.Mimetypehtml");


epages.vars.mimetypeHtmlMap = {
	mimetypes:	{
		'application/x-shockwave-flash' : {
																				classid : 'D27CDB6E-AE6D-11cf-96B8-444553540000',
																				codebase: 'https://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0',
																				template: 'embed',
																				editorclass: 'mceItemFlash'
																			},
		'application/x-director' 				: {
																				classid : '166B1BCA-3F9C-11CF-8075-444553540000',
																				codebase: 'https://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=8,5,1,0',
																				template: 'embed',
																				editorclass: 'mceItemShockWave'
																			},
		'video/quicktime' 							: {
																				classid : '02BF25D5-8C17-4B23-BC80-D3488ABDDC6B',
																				codebase: 'https://www.apple.com/qtactivex/qtplugin.cab#version=6,0,2,0',
																				template: 'embed',
																				editorclass: 'mceItemQuickTime'
																			},
		'audio/x-pn-realaudio-plugin'		: {
																				classid : 'CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA',
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',	// ?? media player
																				template: 'embed',
																				editorclass: 'mceItemRealMedia'
																			},
		'application/vnd.rn-realmedia'	: {
																				classid : 'CFCDAA03-8BE4-11cf-B84B-0020AFBBCCFA',
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',	// ?? media player
																				template: 'embed',
																				editorclass: 'mceItemRealMedia'
																			},
		'application/x-mplayer2'				: {
																				classid : '6BF52A52-394A-11D3-B153-00C04F79FAA6', 																									  // (media_wmp6_compatible') ? '05589FA1-C356-11CE-BF01-00AA0055595A' : '6BF52A52-394A-11D3-B153-00C04F79FAA6';
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
																				template: 'embed',
																				editorclass: 'mceItemWindowsMedia'
																			},
		'video/x-msvideo'								: {
																				classid : '6BF52A52-394A-11D3-B153-00C04F79FAA6', 																									  // (media_wmp6_compatible') ? '05589FA1-C356-11CE-BF01-00AA0055595A' : '6BF52A52-394A-11D3-B153-00C04F79FAA6';
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
																				template: 'embed',
																				editorclass: 'mceItemWindowsMedia'
																			},
		'audio/x-ms-wmv'								: {
																				classid : '6BF52A52-394A-11D3-B153-00C04F79FAA6', 																									  // (media_wmp6_compatible') ? '05589FA1-C356-11CE-BF01-00AA0055595A' : '6BF52A52-394A-11D3-B153-00C04F79FAA6';
																				codebase: 'https://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701',
																				template: 'embed',
																				editorclass: 'mceItemWindowsMedia'
																			}
	},

	templates: {
		image: function(mimetype, mimetypemap, params) {
			return '<img mce_src="'+params.src+ '" src="'+params.src+ '" alt="'+params.name+'" style="border: 0px" />';
		},

		link: function(mimetype, mimetypemap, params) {
			return '<a href="'+params.src+ '" target="_blank" >'+params.name+'</a>';
		},

		embed: function(mimetype, mimetypemap, params, insertIntoEditor) {
			if(!insertIntoEditor) {
				var classid = mimetypemap.classid;
				var codebase = mimetypemap.codebase;
				var html = '';

				html += '<object classid="clsid:' + classid + '" codebase="' + codebase + '"';
				html += params.id !== undefined ? ' id="' + params.id + '"' : '';
				html += params.name !== undefined ? ' name="' + params.name + '"' : '';
				html += params.width !== undefined ? ' width="' + params.width + '"' : '';
				html += params.height !== undefined ? ' height="' + params.height + '"' : '';
				html += params.align !== undefined ? ' align="' + params.align + '"' : '';
				html += '>';

				for (var n in params){
					html += '<param name="' + n + '" value="' + params[n] + '">';
				}

				html += '<embed type="' + mimetype + '"';

				for (var n in params){
					html += n + '="' + params[n] + '" ';
				}

				html += '></embed></object>';

				return html;
			} else {
				var html="";
				html += '<img class="'+mimetypemap.editorclass+'" src="'+epages.vars.StoreRoot+'/lib/jQuery/ckeditor/images/spacer.gif" border="0"';
				html += params.width !== undefined ? ' width="' + params.width + '"' : ' width="200"';
				html += params.height !== undefined ? ' height="' + params.height + '"' : ' height="100"';

				html += ' style="';
				html += params.width  !== undefined ? ' width:'  + params.width  + 'px ;' : ' width: 200px;';
				html += params.height !== undefined ? ' height:' + params.height + 'px; ' : ' height: 100px;';

				html += '" title="';
				var i=0
				for (var n in params) {
					if(i!=0){
						html +=',';
					}
					html += n + ":'" + params[n]+"'";
					i++;
				}
				html += '" />';
				return html;
			}
		}
	}
};

getHtmlByMimeType = function(/* string */mimetype,/* array? */params, /* boolean? */insertIntoEditor) {
	var html="";

	if(mimetype==null){
		mimetype="";
	}
	// adjust url param for windows media player
	if(mimetype=="application/x-mplayer2" || mimetype=="video/x-msvideo" || mimetype=="audio/x-ms-wmv"){
		params.url = params.src;
	}
	var mimetypeVar=epages.vars.mimetypeHtmlMap.mimetypes[mimetype];

	if(mimetype.match(/^image/)){
		html=epages.vars.mimetypeHtmlMap.templates['image'](mimetype, mimetypeVar, params);
	}else if(mimetypeVar !== undefined){
		html= epages.vars.mimetypeHtmlMap.templates[mimetypeVar.template](mimetype, mimetypeVar, params, insertIntoEditor);
	}else{
		html= epages.vars.mimetypeHtmlMap.templates['link'](mimetype, mimetypeVar, params);
	}
	return html;
};

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery"] = true;
/*
  Copyright (c) 2006-2007, ePages GmbH
  All Rights Reserved.

  epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery $Revision: 1.47.2.2.2.1 $

*/
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery");




dojo.declare(
  "epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery",
  [epages.widget.LocalizedWidget],
  {
    /**
     * public properties
     */
    attributeName   : '',                    // String - Attribute name (still in use???)
    storeRoot       : epages.vars.StoreRoot, // String - epages StoreRoot e.g. /WebRoot/Store
    siteId          : epages.vars.SiteID,    // String - Site id
    url             : '?',                   // String - request url
    isTinyMCE       : "false",               // Boolean - flag: use mediagalllery to insert into tinymce
    multiSelect     : "true",                // Boolean - media gallery option: enable multiselect
    onApply         : "",                    // Function - media gallery option: apply function
    applyButtonLabel: "",                    // String - media gallery option: label text for apply button
    validFileTypes  : "",                    // String - media gallery option: filter file extension list - show only these
    opener          : '',         // String - flag to define where it is opend from , passed to mediagallery

    /**
     * constants
     */
    MEDIAGALLERY_OFFSET_X: 130,              // [const] Integer - X Offset (still in use???)
    MEDIAGALLERY_OFFSET_Y: 130,              // [const] Integer - Y Offset (still in use???)

    /**
     * private properties
     */
    templateType       : "standard",         // String - seleced template
    defaultTemplateType: "standard",         // [readonly] String - default template
    templateString:"<div class=\"CommandSmallWithLink NoPadding\" dojoAttachPoint=\"clickNode\">\n  <i class=\"Sprite ico_s_openfile\"></i>{InsertFile}\n</div>\n",  // String - template path + filename
    translationName    : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget', 'templates/translation'),            // String - translation path + filename (without file extension)
    _templateMapping : {
      'standard'  : {templateString:"<div class=\"CommandSmallWithLink NoPadding\" dojoAttachPoint=\"clickNode\">\n  <i class=\"Sprite ico_s_openfile\"></i>{InsertFile}\n</div>\n"},
      'icon'      : {templateString:"<div dojoAttachPoint=\"clickNode\">\n  <i dojoAttachPoint=\"imageNode\" class=\"Sprite ico_s_openfile\" title=\"{InsertFile}\"></i>\n</div>\n"},
      'button'    : {templateString:"<button class=\"UploadArea\" dojoAttachPoint=\"clickNode\" type=\"button\">\n  <i class=\"Sprite ico_m_folder\"></i>\n  {InsertFile}\n</button>\n"},
      'invisible' : {templateString:"<span dojoAttachPoint=\"clickNode\"></span>\n"}
    },                                       // [protected] Object - hash which associates templateType key with template filename
    _tinyMceSelection   : undefined,         // [protected] TinyMceSelection - current selection in tiny mce editor
    /**
     * widget properties
     */
    imagePath       : dojo.moduleUrl('dijit', 'themes/epages/images'),  // String - image path

    postMixInProperties: function(){
    // summary: initialize values
      this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget' , 'templates');

      // toolmediagallery as tiny mce button
      this.isTinyMCE = (this.isTinyMCE == 'true' || this.isTinyMCE == '1');
      this.inherited("postMixInProperties", arguments);
    },

    postCreate  : function() {
    // summary: initialize values / adjust nodes
      this.inherited("postCreate", arguments);
      // tinymce button display settings
      if(this.isTinyMCE && this.imageNode){
        this.imageNode.style.margin="2px";
      }

      this._appendEvents();
    },

    /**
     * private methods
     */

    _appendEvents: function() {
      // summary: open gallery
      // tags: callback

      var self = this;
      jQuery.ready({
        plugin:"de_epages.mediagallery.ui.filemanagerdialog",
        DOM: true
      }, function($){
        var backImageLink = (self.inputNode !== undefined) ? de_epages($(self.domNode).find("span.Button")) : de_epages(self.domNode),

            changeImage = function(selectedFile){
            	self.onApply("MediaGallery" + selectedFile.get("path"));
            };

        backImageLink.mediagalleryUiFilemanagerdialog({
          dialog: {
            buttons: {
              Ok: {click: function(){
                  var item = backImageLink.mediagalleryUiFilemanagerdialog("getSelectedElements")[0];

                  if(item){
                    if(item.get("metadata").type !== "MediaGallery"){
                      ep.ajax({
                        dataType: "json",
                        type : "POST",
                        data : {
                          ChangeAction : "JSONCopyImageFromImageDb",
                          StyleID: epConfig.objectId,
                          ObjectID : epConfig.siteId,
                          SourceFile : item.get("fullpath"),
                          TargetDirectory : "",
                          ViewAction : 'JSONViewResponse'
                        }
                      })
                      .done(function( jsonData, statusText, jqXHR ){
                        item.set({path: jsonData.Files[0].path});
                        changeImage(item);
                      });
                    }
                    else{
                      changeImage(item);
                    }
                  }

                  ep(this).uiDialog("close");
                }
              },
              Cancel:{
                click: function(){
                  ep(this).uiDialog("close");
                }
              }
            },
            close: function(){
              backImageLink.mediagalleryUiFilemanagerdialog("resetFilemanager");
            }
          },
          filemanager: {
            currentFolder: "BackgroundImages",
            selectable: "image/jpe,image/jpg,image/jpeg,image/gif,image/png",
          }
        });
      });
    },

    setFileTypes: function(/* String */ fileTypes) {
      // summary: updates the list of allowed file extensions

      if(typeof(fileTypes) === "string" && (this.validFileTypes != fileTypes)) {
        this.validFileTypes = fileTypes;
        var MediaGallery = $$('MediaGallery');
        if(MediaGallery !== undefined) {
          MediaGallery.setFileTypes(this.validFileTypes);
        }
      }
    },

    openDialog: function(/*Event*/evt) {
      // summary: Show MediaGallery
      // description: Calls show() of the mediagallery widget (widgetId=MediaGallery)

      if(!this.isMediaSelected && !this.isImageSelected) {
        var MediaGallery = $$('MediaGallery');
        // set onApply function
        var onApply = '';
        if(this.onApply != "") {
          onApply=this.onApply;
        } else if (this.isTinyMCE) {
          var me = this;
          onApply= function(selected) {
            var generatedHtml="";
            $A(selected).each(function (el) {
              generatedHtml+=me.mceGenerateContent(el)+'<br />';
            });
            me.mceInsertContent(generatedHtml);
          };
        }
        if(MediaGallery === undefined) {
          epages.require('ep_shop_tree','dijit.Tree');
          epages.require('ep_shop_upload','epages.uploader');
          epages.require('ep_mediagallery', 'epages.cartridges.de_epages.mediagallery.widget.Mediagallery');
          MediaGallery = new epages.cartridges.de_epages.mediagallery.widget.Mediagallery({
            id:               'MediaGallery',
            siteId:           this.siteId,
            url:              this.url,
            applyButtonLabel: this.applyButtonLabel,
            multiSelect:      this.multiSelect,
            validFileTypes:   this.validFileTypes,
            onApply:          onApply,
            opener:           this.opener
          });

          document.getElementsByTagName("body")[0].appendChild(MediaGallery.domNode);
        } else {
          MediaGallery.setOnApply(onApply);
        }
        MediaGallery.changeOpener(this.opener);
        MediaGallery.show();
      }
    },

    mceGenerateContent: function(el) {
    // summary:
    //      generates the tiny mce code (mimetype dependent)
    // el: epages.cartridges.de_epages.mediagallery.widget.Filelistitem
    //      selected file list item
    // tags:
    //      protected
      epages.require('ep_mediagallery', 'epages.cartridges.de_epages.mediagallery.Mimetypehtml');
      var html= getHtmlByMimeType(el.mimetype, {src: el.fullpath, name: el.fileName}, true);
      return html;
    },

    mceInsertContent: function (/* String */ html) {
    // summary:
    //      insert code into tiny mce
    // html:
    //      this html code will be inserted into tiny mce
    // tags:
    //      protected
      if(tinyMCE && tinyMCE.activeEditor){
        tinyMCE.activeEditor.selection.moveToBookmark(tinymce.WindowManager.bookmark);
        tinyMCE.activeEditor.execCommand('mceInsertContent', false, html);
      }
    }

  }
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.ImageInlineEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.mediagallery.widget.ImageInlineEditor"] = true;
dojo.provide("epages.cartridges.de_epages.mediagallery.widget.ImageInlineEditor");


(function(jq){

  var jqUploaderReady = !1,
      jqUploaderCreate = function( self ){
        var data = {
            ViewAction:		'JSONViewResponse',
            ChangeAction:	self.uploadAction,
            ObjectID:		self.objectId,
          };
        if( self.scaleWidth ){ data.Width	= self.scaleWidth; }
        if( self.scaleHeight ){ data.Heigh	= self.scaleHeight; }
        if( self.image ){ data.Image	= self.image; }

        de_epages(self.uploadNode)
          .presentationUiUploader({
            data:			data,
            style:		'big-icon',
            accept:		self.fileType,
            callback:	function( data ){
              if( data = data[ data.length-1 ].success ){
                self.onChange(data.uploadedObjectFile,data.uploadedFile);
              }
            }
          });
      };

  dojo.declare(
    "epages.cartridges.de_epages.mediagallery.widget.ImageInlineEditor",
    [epages.cartridges.de_epages.presentation.widget.InlineEditor],
    {
      /* widget properties */
      templateString		: '',
      templateString:"<div class=\"InlineEditor ImageInlineEditor LinkImage EnableHover\">\n  <img dojoAttachEvent=\"onmousedown:show\" dojoAttachPoint=\"imgNode\" src=\"${value}\" />\n  <div class=\"ImageInlineEditorButton\" style=\"overflow:visible !important;\">\n    <input type=\"file\" dojoAttachPoint=\"uploadNode\"/>\n<!--\n    <div class=\"FloatLeft Button EnableHover Large\" dojoAttachPoint=\"uploadNode\" id=\"InlineEditor_${id}\">\n      <span class=\"ButtonIconContainer\"><i class=\"MultipleUploadFlashButtonBig\"></i></span>\n    </div>\n-->\n  </div>\n  <input type=\"hidden\" dojoAttachPoint=\"contentNode\" name=\"${inputName}\" value=\"${value}\" />\n</div>\n",
      widgetsInTemplate : true,
      objectId          : epages.vars.ObjectID || '',
      uploadAction      : 'UploadImages',
      scaleWidth        : null,
      scaleHeight       : null,

      /* public properties */
      permanent: true,
      image: null,

      postCreate: function(){
        if(this.value == ''){
          this.imgNode.src = epages.themeUrl('images') + "/plain.gif";
          this.imgNode.width= 50;
          this.imgNode.height = 50;
        }

        if(this.scaleWidth != null) {
          this.scaleWidth = parseInt(this.scaleWidth, 10);
        }
        if(this.scaleHeight != null) {
          this.scaleHeight = parseInt(this.scaleHeight, 10);
        }

        // modify changeaction
        this._changeUploader();

        this.inherited('postCreate', arguments);
      },

      startup: function() {
        this.inherited('startup', arguments);
        this.domNode.title = "";

      },

      _changeUploader: function () {
        var self = this;

        if( jqUploaderReady ){
            jqUploaderCreate( self );
        }
        else{
          jq.ready( 'de_epages.presentation.ui.uploader', function(){
            jqUploaderReady = !0;
            jqUploaderCreate( self );
          });
        }
      },

      onChange: function(value,imgSrc) {
        this.imgNode.src = imgSrc;
        // write contents back to hidden input
        this.contentNode.value = value;
        //this.undoObject.addInput(this.contentNode);
      },

      show: function(evt) {
        // Upload widget
        //this.uploadNode.uploadFiles(evt);
      },

      hide: function() {
        // this is a permanent widget, so it never hides
      },

      _copyStyle: function(){
        //description: empty function from parent widget is not used in this widget
      }

    }
  );

})(jQuery);

}

if(!dojo._hasResource['epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput'] = true;
/*
	Copyright (c) 2006-2010, epages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput $Revision: 1.8.76.1 $

*/
dojo.provide('epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput');



dojo.declare("epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput",
	[epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery],
	{
		value              : '',	       // String - input field value
		name               : '',         // String - name of input field
		multiSelect        : "false",    // [readonly] Boolean - media gallery option: enable multiselect
		onApply            : undefined , // [protected] Function - media gallery onapply callback
		relativeToSiteRoot : 'false',    // Boolean - input value will be relative to the site path (epages.vars.SiteRoot)
		'class'            : '',

		templateString:"<span class=\"MediaGalleryInput ${class}\">\n  <input type=\"text\" readonly=\"readonly\" name=\"${name}\" value=\"${value}\" dojoAttachPoint=\"inputNode\" />\n  <span class=\"Button EnableHover\" dojoAttachPoint=\"clickNode\">\n    <span class=\"ButtonContainer\">{SelectFile}</span>\n  </span>\n  <i class=\"Sprite ico_s_remove ClickIcon\" dojoAttachPoint=\"removeNode\" style=\"visibility:hidden\"></i>\n</span>\n",
		_templateMapping : {
			'standard' : {templateString:"<span class=\"MediaGalleryInput ${class}\">\n  <input type=\"text\" readonly=\"readonly\" name=\"${name}\" value=\"${value}\" dojoAttachPoint=\"inputNode\" />\n  <span class=\"Button EnableHover\" dojoAttachPoint=\"clickNode\">\n    <span class=\"ButtonContainer\">{SelectFile}</span>\n  </span>\n  <i class=\"Sprite ico_s_remove ClickIcon\" dojoAttachPoint=\"removeNode\" style=\"visibility:hidden\"></i>\n</span>\n"}
		},                               // [protected] Object - hash which associates templateType key with template filename

		postMixInProperties: function() {
		// summary: initalize values - adjust properites
			this.inherited("postMixInProperties", arguments);
			var mediagalleryInputScope = this;
			this.relativeToSiteRoot =  epages.string.toBoolean(this.relativeToSiteRoot);

			this.onApply = function(path) {
			// summary:
			//			media gallery onapply callback
			// items : epages.cartridges.de_epages.mediagallery.widget.Filelistitem[]
			//			list with possible itens
			// tags:
			//			callback
				mediagalleryInputScope.inputNode.value = path;
				epages.event.fire(mediagalleryInputScope.inputNode, 'change');
			};
		},

		postCreate: function() {
		// summary: adjust nodes and events
			this.inherited("postCreate", arguments);
			this.adjustRemoveNodeDisplay();
			this.connect(this.removeNode, 'onclick', 'removeValue');
			this.connect(this.inputNode, 'onchange', 'onChange');
		},

		onChange : function() {
		// summary: adjust display of remove node
			this.syncValue();
			this.adjustRemoveNodeDisplay();
		},

		adjustRemoveNodeDisplay: function() {
		// summary: adjust display of remove node
		// tags: protected
			if(this.value == "") {
				this.removeNode.style.visibility = "hidden";
			} else {
				this.removeNode.style.visibility = "";
			}
		},

		syncValue : function() {
		// summary: synch input value and this.value
		// tags: protected
			this.value = this.inputNode.value;
		},

		removeValue : function() {
		// summary: adjust display of remove node
		// tags: callback
			this.inputNode.value = "";
			epages.event.fire(this.inputNode, 'change');
		}

});

}

