/*
	Copyright (c) 2006-2010, epages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput $Revision: 1.8.76.1 $

*/
dojo.provide('epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput');
dojo.require('epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery');
dojo.require('epages.event');

dojo.declare("epages.cartridges.de_epages.mediagallery.widget.MediagalleryInput",
	[epages.cartridges.de_epages.mediagallery.widget.Toolmediagallery],
	{
		value              : '',	       // String - input field value
		name               : '',         // String - name of input field
		multiSelect        : "false",    // [readonly] Boolean - media gallery option: enable multiselect
		onApply            : undefined , // [protected] Function - media gallery onapply callback
		relativeToSiteRoot : 'false',    // Boolean - input value will be relative to the site path (epages.vars.SiteRoot)
		'class'            : '',

		templatePath       : dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget', 'templates/MediagalleryInput.html'),
		_templateMapping : {
			'standard' : {templatePath: dojo.moduleUrl('epages.cartridges.de_epages.mediagallery.widget', 'templates/MediagalleryInput.html')}
		},                               // [protected] Object - hash which associates templateType key with template filename

		postMixInProperties: function() {
		// summary: initalize values - adjust properites
			this.inherited("postMixInProperties", arguments);
			var mediagalleryInputScope = this;
			this.relativeToSiteRoot =  epages.string.toBoolean(this.relativeToSiteRoot);

			this.onApply = function(path) {
			// summary:
			//			media gallery onapply callback
			// items : epages.cartridges.de_epages.mediagallery.widget.Filelistitem[]
			//			list with possible itens
			// tags:
			//			callback
				mediagalleryInputScope.inputNode.value = path;
				epages.event.fire(mediagalleryInputScope.inputNode, 'change');
			};
		},

		postCreate: function() {
		// summary: adjust nodes and events
			this.inherited("postCreate", arguments);
			this.adjustRemoveNodeDisplay();
			this.connect(this.removeNode, 'onclick', 'removeValue');
			this.connect(this.inputNode, 'onchange', 'onChange');
		},

		onChange : function() {
		// summary: adjust display of remove node
			this.syncValue();
			this.adjustRemoveNodeDisplay();
		},

		adjustRemoveNodeDisplay: function() {
		// summary: adjust display of remove node
		// tags: protected
			if(this.value == "") {
				this.removeNode.style.visibility = "hidden";
			} else {
				this.removeNode.style.visibility = "";
			}
		},

		syncValue : function() {
		// summary: synch input value and this.value
		// tags: protected
			this.value = this.inputNode.value;
		},

		removeValue : function() {
		// summary: adjust display of remove node
		// tags: callback
			this.inputNode.value = "";
			epages.event.fire(this.inputNode, 'change');
		}

});